;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.1.0 #12072 (Linux)
;--------------------------------------------------------
	.module tbasic
	.optsdcc -mstm8
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _portmap
	.globl _pinmap
	.globl _i_nsb
	.globl _i_nsa
	.globl _main
	.globl _basic
	.globl _error
	.globl _icom
	.globl _inew
	.globl _ilist
	.globl _irun
	.globl _iexe
	.globl _ilet
	.globl _iarray
	.globl _ivar
	.globl _iinput
	.globl _iprint
	.globl _iplus
	.globl _imul
	.globl _ivalue
	.globl _ioutput
	.globl _adc_read
	.globl _iioin
	.globl _io_inputinit
	.globl _ibyteout
	.globl _io_outputinit
	.globl _io_bitset
	.globl _io_set
	.globl _io_get
	.globl _io_adr
	.globl _get_port
	.globl _getparam
	.globl _putlist
	.globl _inslist
	.globl _getsize
	.globl _getlp
	.globl _getlineno
	.globl _toktoi
	.globl _getnum
	.globl _putnum
	.globl _uart_getstring
	.globl _uart_readkey
	.globl _c_isalpha
	.globl _c_isdigit
	.globl _c_isspace
	.globl _c_isprint
	.globl _c_toupper
	.globl _loadprog
	.globl _saveprog
	.globl _eeprom_read
	.globl _eeprom_write
	.globl _eeprom_unlock
	.globl _sstyle
	.globl _getrnd
	.globl _newline
	.globl _uart_putstring
	.globl _uart_init
	.globl _uart_ischar
	.globl _uart_getchar
	.globl _uart_putchar
	.globl _delay_us
	.globl _delay
	.globl _sysclock_init
	.globl _strcpy
	.globl _rand
	.globl _portddr
	.globl _errmsg
	.globl _kwtbl
	.globl _err
	.globl _lstki
	.globl _lstk
	.globl _gstki
	.globl _gstk
	.globl _cip
	.globl _clp
	.globl _listbuf
	.globl _arr
	.globl _var
	.globl _ibuf
	.globl _lbuf
	.globl _iexp
	.globl _sysfunc
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area DATA
_lbuf::
	.ds 40
_ibuf::
	.ds 40
_var::
	.ds 52
_arr::
	.ds 64
_listbuf::
	.ds 512
_clp::
	.ds 2
_cip::
	.ds 2
_gstk::
	.ds 12
_gstki::
	.ds 1
_lstk::
	.ds 30
_lstki::
	.ds 1
_err::
	.ds 1
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area INITIALIZED
_kwtbl::
	.ds 84
_errmsg::
	.ds 52
_portddr::
	.ds 2
;--------------------------------------------------------
; Stack segment in internal ram 
;--------------------------------------------------------
	.area	SSEG
__start__stack:
	.ds	1

;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area DABS (ABS)

; default segment ordering for linker
	.area HOME
	.area GSINIT
	.area GSFINAL
	.area CONST
	.area INITIALIZER
	.area CODE

;--------------------------------------------------------
; interrupt vector 
;--------------------------------------------------------
	.area HOME
__interrupt_vect:
	int s_GSINIT ; reset
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area HOME
	.area GSINIT
	.area GSFINAL
	.area GSINIT
__sdcc_init_data:
; stm8_genXINIT() start
	ldw x, #l_DATA
	jreq	00002$
00001$:
	clr (s_DATA - 1, x)
	decw x
	jrne	00001$
00002$:
	ldw	x, #l_INITIALIZER
	jreq	00004$
00003$:
	ld	a, (s_INITIALIZER - 1, x)
	ld	(s_INITIALIZED - 1, x), a
	decw	x
	jrne	00003$
00004$:
; stm8_genXINIT() end
	.area GSFINAL
	jp	__sdcc_program_startup
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME
	.area HOME
__sdcc_program_startup:
	jp	_main
;	return from main will return to caller
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CODE
;	tbasic.c: 92: void newline(void)
;	-----------------------------------------
;	 function newline
;	-----------------------------------------
_newline:
;	tbasic.c: 98: uart_putstring("\n\r");
	push	#<(___str_0+0)
	push	#((___str_0+0) >> 8)
	call	_uart_putstring
	popw	x
;	tbasic.c: 99: }
	ret
;	tbasic.c: 101: int16_t getrnd(int16_t value)
;	-----------------------------------------
;	 function getrnd
;	-----------------------------------------
_getrnd:
;	tbasic.c: 103: return (rand() % value) + 1;
	call	_rand
	ldw	y, (0x03, sp)
	pushw	y
	pushw	x
	call	__modsint
	addw	sp, #4
	incw	x
;	tbasic.c: 104: }
	ret
;	tbasic.c: 165: char sstyle(uint8_t code, const uint8_t *table, uint8_t count)
;	-----------------------------------------
;	 function sstyle
;	-----------------------------------------
_sstyle:
	push	a
;	tbasic.c: 167: while (count--)
	ld	a, (0x07, sp)
	ld	(0x01, sp), a
00103$:
	ld	a, (0x01, sp)
	dec	(0x01, sp)
	tnz	a
	jreq	00105$
;	tbasic.c: 168: if (code == table[count])
	clrw	x
	ld	a, (0x01, sp)
	ld	xl, a
	addw	x, (0x05, sp)
	ld	a, (x)
;	tbasic.c: 169: return 1;
	sub	a, (0x04, sp)
	jrne	00103$
	inc	a
;	tbasic.c: 170: return 0;
	.byte 0x21
00105$:
	clr	a
00106$:
;	tbasic.c: 171: }
	addw	sp, #1
	ret
;	tbasic.c: 299: void eeprom_unlock(void)
;	-----------------------------------------
;	 function eeprom_unlock
;	-----------------------------------------
_eeprom_unlock:
;	tbasic.c: 301: if (!(FLASH_IAPSR & FLASH_IAPSR_DUL))
	ld	a, 0x505f
	bcp	a, #0x08
	jrne	00102$
;	tbasic.c: 302: FLASH_DUKR= 0xae;
	mov	0x5064+0, #0xae
00102$:
;	tbasic.c: 303: FLASH_DUKR= 0x56;
	mov	0x5064+0, #0x56
;	tbasic.c: 304: }
	ret
;	tbasic.c: 314: uint8_t eeprom_write(uint16_t addr, uint8_t value)
;	-----------------------------------------
;	 function eeprom_write
;	-----------------------------------------
_eeprom_write:
;	tbasic.c: 316: uint8_t *address = (char *) EEPROM_BASE_ADDR + addr;
	ldw	x, (0x03, sp)
	addw	x, #0x4000
;	tbasic.c: 318: if (addr > 0x027f) return 0;                  // 0x27f = 639 = hoechste verfuegbare
	ldw	y, (0x03, sp)
	cpw	y, #0x027f
	jrule	00102$
	clr	a
	ret
00102$:
;	tbasic.c: 320: *address = (uint8_t) value;
	ld	a, (0x05, sp)
	ld	(x), a
;	tbasic.c: 321: return 1;
	ld	a, #0x01
;	tbasic.c: 322: }
	ret
;	tbasic.c: 330: uint8_t eeprom_read(uint16_t addr)
;	-----------------------------------------
;	 function eeprom_read
;	-----------------------------------------
_eeprom_read:
;	tbasic.c: 333: uint8_t *address = (char *) EEPROM_BASE_ADDR + addr;
	ldw	x, (0x03, sp)
	addw	x, #0x4000
;	tbasic.c: 335: if (addr > 0x027f) return 0xff;               // 0x27f = 639 = hoechste verfuegbare
	ldw	y, (0x03, sp)
	cpw	y, #0x027f
	jrule	00102$
	ld	a, #0xff
	ret
00102$:
;	tbasic.c: 337: value= *address;
	ld	a, (x)
;	tbasic.c: 338: return value;
;	tbasic.c: 339: }
	ret
;	tbasic.c: 342: void saveprog(void)
;	-----------------------------------------
;	 function saveprog
;	-----------------------------------------
_saveprog:
;	tbasic.c: 346: eeprom_unlock();
	call	_eeprom_unlock
;	tbasic.c: 348: for (adr= 0; adr< SIZE_LIST; adr++)
	clrw	x
00102$:
;	tbasic.c: 350: eeprom_write(adr, listbuf[adr]);
	ldw	y, x
	ld	a, (_listbuf+0, y)
	pushw	x
	push	a
	pushw	x
	call	_eeprom_write
	addw	sp, #3
	popw	x
;	tbasic.c: 348: for (adr= 0; adr< SIZE_LIST; adr++)
	incw	x
	ldw	y, x
	cpw	y, #0x0200
	jrc	00102$
;	tbasic.c: 352: eeprom_lock();
	bres	20575, #3
;	tbasic.c: 353: uart_putstring("\n\rDone...");
	push	#<(___str_1+0)
	push	#((___str_1+0) >> 8)
	call	_uart_putstring
	popw	x
;	tbasic.c: 354: }
	ret
;	tbasic.c: 356: void loadprog(void)
;	-----------------------------------------
;	 function loadprog
;	-----------------------------------------
_loadprog:
;	tbasic.c: 360: eeprom_unlock();
	call	_eeprom_unlock
;	tbasic.c: 362: for (adr= 0; adr< SIZE_LIST; adr++)
	clrw	y
00102$:
;	tbasic.c: 364: listbuf[adr]= eeprom_read(adr);
	ldw	x, y
	addw	x, #(_listbuf+0)
	pushw	x
	pushw	y
	pushw	y
	call	_eeprom_read
	popw	x
	popw	y
	popw	x
	ld	(x), a
;	tbasic.c: 362: for (adr= 0; adr< SIZE_LIST; adr++)
	incw	y
	ldw	x, y
	cpw	x, #0x0200
	jrc	00102$
;	tbasic.c: 366: eeprom_lock();
	bres	20575, #3
;	tbasic.c: 367: uart_putstring("\n\rLoading done...");
	push	#<(___str_2+0)
	push	#((___str_2+0) >> 8)
	call	_uart_putstring
	popw	x
;	tbasic.c: 368: }
	ret
;	tbasic.c: 370: char c_toupper(char c)
;	-----------------------------------------
;	 function c_toupper
;	-----------------------------------------
_c_toupper:
;	tbasic.c: 373: return(c <= 'z' && c >= 'a' ? c - 32 : c);
	ld	a, (0x03, sp)
	cp	a, #0x7a
	jrugt	00103$
	ld	a, (0x03, sp)
	cp	a, #0x61
	jrc	00103$
	sub	a, #0x20
	ret
00103$:
	ld	a, (0x03, sp)
;	tbasic.c: 374: }
	ret
;	tbasic.c: 376: char c_isprint(char c)
;	-----------------------------------------
;	 function c_isprint
;	-----------------------------------------
_c_isprint:
;	tbasic.c: 378: return(c >= 32 && c <= 126);
	ld	a, (0x03, sp)
	cp	a, #0x20
	jrc	00103$
	cp	a, #0x7e
	jrule	00104$
00103$:
	clr	a
	ret
00104$:
	ld	a, #0x01
;	tbasic.c: 379: }
	ret
;	tbasic.c: 381: char c_isspace(char c)
;	-----------------------------------------
;	 function c_isspace
;	-----------------------------------------
_c_isspace:
;	tbasic.c: 383: return(c == ' ' || (c <= 13 && c >= 9));
	ld	a, (0x03, sp)
	cp	a, #0x20
	jreq	00104$
	ld	a, (0x03, sp)
	cp	a, #0x0d
	jrugt	00103$
	ld	a, (0x03, sp)
	cp	a, #0x09
	jrnc	00104$
00103$:
	clr	a
	ret
00104$:
	ld	a, #0x01
;	tbasic.c: 384: }
	ret
;	tbasic.c: 386: char c_isdigit(char c)
;	-----------------------------------------
;	 function c_isdigit
;	-----------------------------------------
_c_isdigit:
;	tbasic.c: 388: return(c <= '9' && c >= '0');
	ld	a, (0x03, sp)
	cp	a, #0x39
	jrugt	00103$
	ld	a, (0x03, sp)
	cp	a, #0x30
	jrnc	00104$
00103$:
	clr	a
	ret
00104$:
	ld	a, #0x01
;	tbasic.c: 389: }
	ret
;	tbasic.c: 391: char c_isalpha(char c)
;	-----------------------------------------
;	 function c_isalpha
;	-----------------------------------------
_c_isalpha:
;	tbasic.c: 393: return ((c <= 'z' && c >= 'a') || (c <= 'Z' && c >= 'A'));
	ld	a, (0x03, sp)
	cp	a, #0x7a
	jrugt	00108$
	ld	a, (0x03, sp)
	cp	a, #0x61
	jrnc	00104$
00108$:
	ld	a, (0x03, sp)
	cp	a, #0x5a
	jrugt	00103$
	ld	a, (0x03, sp)
	cp	a, #0x41
	jrnc	00104$
00103$:
	clr	a
	ret
00104$:
	ld	a, #0x01
;	tbasic.c: 394: }
	ret
;	tbasic.c: 396: char uart_readkey()
;	-----------------------------------------
;	 function uart_readkey
;	-----------------------------------------
_uart_readkey:
;	tbasic.c: 400: c= uart_getchar();
	call	_uart_getchar
;	tbasic.c: 401: if (c== return_alt) return return_key;
	cp	a, #0x0a
	jreq	00112$
	ret
00112$:
	ld	a, #0x0d
;	tbasic.c: 402: return c;
;	tbasic.c: 403: }
	ret
;	tbasic.c: 405: void uart_getstring(void)
;	-----------------------------------------
;	 function uart_getstring
;	-----------------------------------------
_uart_getstring:
	pushw	x
;	tbasic.c: 410: len = 0;
	clr	(0x02, sp)
;	tbasic.c: 411: while  ((c = uart_readkey()) != return_key)
00111$:
	call	_uart_readkey
	ld	xl, a
	push	a
	ld	a, xl
	cp	a, #0x0d
	pop	a
	jreq	00113$
;	tbasic.c: 413: if (c == 9) c = ' ';                                // TAB durch Leerzeichen ersetzen
	cp	a, #0x09
	jrne	00102$
	ld	a, #0x20
00102$:
;	tbasic.c: 414: if (((c == 8) || (c == 127)) && (len > 0))          // letztes Zeichen loeschen
	cp	a, #0x08
	jreq	00110$
	cp	a, #0x7f
	jrne	00107$
00110$:
	tnz	(0x02, sp)
	jreq	00107$
;	tbasic.c: 416: len--;
	dec	(0x02, sp)
;	tbasic.c: 417: uart_putchar(8);
	push	#0x08
	call	_uart_putchar
	pop	a
;	tbasic.c: 418: uart_putchar(' ');
	push	#0x20
	call	_uart_putchar
	pop	a
;	tbasic.c: 419: uart_putchar(8);
	push	#0x08
	call	_uart_putchar
	pop	a
	jra	00111$
00107$:
;	tbasic.c: 423: if (c_isprint(c) && (len < (SIZE_LINE - 1)))
	push	a
	push	a
	call	_c_isprint
	addw	sp, #1
	ld	(0x02, sp), a
	pop	a
	tnz	(0x01, sp)
	jreq	00111$
	push	a
	ld	a, (0x03, sp)
	cp	a, #0x27
	pop	a
	jrnc	00111$
;	tbasic.c: 425: lbuf[len++] = c;
	exg	a, xl
	ld	a, (0x02, sp)
	exg	a, xl
	inc	(0x02, sp)
	rlwa	x
	clr	a
	rrwa	x
	addw	x, #(_lbuf+0)
	ld	(x), a
;	tbasic.c: 426: uart_putchar(c);
	push	a
	call	_uart_putchar
	pop	a
	jra	00111$
00113$:
;	tbasic.c: 430: newline();
	call	_newline
;	tbasic.c: 431: lbuf[len] = 0;
	clrw	x
	ld	a, (0x02, sp)
	ld	xl, a
	clr	((_lbuf+0), x)
;	tbasic.c: 432: if (len > 0)
	tnz	(0x02, sp)
	jreq	00119$
;	tbasic.c: 434: while (c_isspace(lbuf[--len]));                    // Leerzeichen uebergehen
00114$:
	dec	(0x02, sp)
	clrw	x
	ld	a, (0x02, sp)
	ld	xl, a
	ld	a, (_lbuf+0, x)
	push	a
	call	_c_isspace
	addw	sp, #1
	tnz	a
	jrne	00114$
;	tbasic.c: 435: lbuf[++len] = 0;
	ld	a, (0x02, sp)
	inc	a
	clrw	x
	ld	xl, a
	clr	((_lbuf+0), x)
00119$:
;	tbasic.c: 437: }
	popw	x
	ret
;	tbasic.c: 439: void putnum(int16_t value, int16_t d)
;	-----------------------------------------
;	 function putnum
;	-----------------------------------------
_putnum:
	sub	sp, #5
;	tbasic.c: 444: if (value < 0)
	ldw	x, (0x08, sp)
	jrpl	00102$
;	tbasic.c: 446: sign = 1;
	ld	a, #0x01
	ld	(0x01, sp), a
;	tbasic.c: 447: value = -value;
	ldw	x, (0x08, sp)
	negw	x
	ldw	(0x08, sp), x
;	tbasic.c: 451: sign = 0;
	.byte 0xc5
00102$:
	clr	(0x01, sp)
00103$:
;	tbasic.c: 454: lbuf[6] = 0;
	ldw	x, #(_lbuf+0)+6
	clr	(x)
;	tbasic.c: 456: do
	ldw	x, #0x0006
	ldw	(0x04, sp), x
00104$:
;	tbasic.c: 458: lbuf[--dig] = (value % 10) + '0';
	ldw	x, (0x04, sp)
	decw	x
	ldw	(0x04, sp), x
	addw	x, #(_lbuf+0)
	ldw	(0x02, sp), x
	ldw	y, (0x08, sp)
	pushw	y
	push	#0x0a
	push	#0x00
	pushw	y
	call	__modsint
	addw	sp, #4
	ld	a, xl
	popw	y
	add	a, #0x30
	ldw	x, (0x02, sp)
	ld	(x), a
;	tbasic.c: 459: value /= 10;
	push	#0x0a
	push	#0x00
	pushw	y
	call	__divsint
	addw	sp, #4
;	tbasic.c: 460: }while (value > 0);
	ldw	(0x08, sp), x
	cpw	x, #0x0000
	jrsgt	00104$
;	tbasic.c: 462: if (sign) lbuf[--dig] = '-';
	ldw	y, (0x04, sp)
	ldw	(0x02, sp), y
	tnz	(0x01, sp)
	jreq	00119$
	ldw	x, (0x04, sp)
	decw	x
	ldw	(0x02, sp), x
	ld	a, #0x2d
	ld	((_lbuf+0), x), a
;	tbasic.c: 464: while (6 - dig < d)
00119$:
	ldw	x, #0x0006
	subw	x, (0x02, sp)
	ldw	y, (0x0a, sp)
00109$:
	ldw	(0x04, sp), y
	cpw	x, (0x04, sp)
	jrnc	00111$
;	tbasic.c: 466: uart_putchar(' ');
	pushw	x
	pushw	y
	push	#0x20
	call	_uart_putchar
	pop	a
	popw	y
	popw	x
;	tbasic.c: 467: d--;
	decw	y
	jra	00109$
00111$:
;	tbasic.c: 469: uart_putstring(&lbuf[dig]);
	ldw	x, (0x02, sp)
	addw	x, #(_lbuf+0)
	pushw	x
	call	_uart_putstring
;	tbasic.c: 470: }
	addw	sp, #7
	ret
;	tbasic.c: 472: int16_t getnum(void)
;	-----------------------------------------
;	 function getnum
;	-----------------------------------------
_getnum:
	sub	sp, #4
;	tbasic.c: 479: len = 0;
	clr	(0x04, sp)
;	tbasic.c: 480: while ((c = uart_readkey()) != return_key)
00112$:
	call	_uart_readkey
	ld	xl, a
	push	a
	ld	a, xl
	cp	a, #0x0d
	pop	a
	jreq	00114$
;	tbasic.c: 482: if (((c == 8) || (c == 127)) && (len > 0))               // Del-Taste
	cp	a, #0x08
	jreq	00111$
	cp	a, #0x7f
	jrne	00108$
00111$:
	tnz	(0x04, sp)
	jreq	00108$
;	tbasic.c: 484: len--;
	dec	(0x04, sp)
;	tbasic.c: 485: uart_putchar(8);
	push	#0x08
	call	_uart_putchar
	pop	a
;	tbasic.c: 486: uart_putchar(' ');
	push	#0x20
	call	_uart_putchar
	pop	a
;	tbasic.c: 487: uart_putchar(8);
	push	#0x08
	call	_uart_putchar
	pop	a
	jra	00112$
00108$:
;	tbasic.c: 491: if ((len == 0 && (c == '+' || c == '-')) || (len < 6 && c_isdigit(c)))
	tnz	(0x04, sp)
	jrne	00106$
	cp	a, #0x2b
	jreq	00101$
	cp	a, #0x2d
	jreq	00101$
00106$:
	push	a
	ld	a, (0x05, sp)
	cp	a, #0x06
	pop	a
	jrnc	00112$
	push	a
	push	a
	call	_c_isdigit
	addw	sp, #1
	ld	(0x04, sp), a
	pop	a
	tnz	(0x03, sp)
	jreq	00112$
00101$:
;	tbasic.c: 493: lbuf[len++] = c;
	exg	a, xl
	ld	a, (0x04, sp)
	exg	a, xl
	inc	(0x04, sp)
	rlwa	x
	clr	a
	rrwa	x
	addw	x, #(_lbuf+0)
	ld	(x), a
;	tbasic.c: 494: uart_putchar(c);
	push	a
	call	_uart_putchar
	pop	a
	jra	00112$
00114$:
;	tbasic.c: 498: newline();
	call	_newline
;	tbasic.c: 499: lbuf[len] = 0;
	clrw	x
	ld	a, (0x04, sp)
	ld	xl, a
	clr	((_lbuf+0), x)
;	tbasic.c: 501: switch (lbuf[0])
	ld	a, _lbuf+0
	cp	a, #0x2b
	jreq	00116$
;	tbasic.c: 504: sign = 1;
;	tbasic.c: 505: len = 1;
	sub	a, #0x2d
	jrne	00117$
	inc	a
	ld	(0x01, sp), a
;	tbasic.c: 506: break;
	jra	00118$
;	tbasic.c: 507: case '+':
00116$:
;	tbasic.c: 508: sign = 0;
	clr	(0x01, sp)
;	tbasic.c: 509: len = 1;
	ld	a, #0x01
;	tbasic.c: 510: break;
	jra	00118$
;	tbasic.c: 511: default:
00117$:
;	tbasic.c: 512: sign = 0;
	clr	(0x01, sp)
;	tbasic.c: 513: len = 0;
	clr	a
;	tbasic.c: 515: }
00118$:
;	tbasic.c: 517: value = 0;
	clrw	x
;	tbasic.c: 520: while (lbuf[len])
	ld	(0x04, sp), a
00121$:
	clrw	y
	ld	a, (0x04, sp)
	ld	yl, a
	addw	y, #(_lbuf+0)
	ld	a, (y)
	jreq	00123$
;	tbasic.c: 522: tmp = 10 * value + lbuf[len++] - '0';
	ldw	(0x02, sp), x
	pushw	x
	ldw	x, (0x04, sp)
	sllw	x
	sllw	x
	addw	x, (0x04, sp)
	sllw	x
	exgw	x, y
	popw	x
	inc	(0x04, sp)
	ld	(0x03, sp), a
	clr	(0x02, sp)
	addw	y, (0x02, sp)
	subw	y, #0x0030
	ldw	(0x02, sp), y
;	tbasic.c: 523: if (value > tmp)                            // Werteueberlauf
	cpw	x, (0x02, sp)
	jrsle	00120$
;	tbasic.c: 525: err = ERR_VOF;
	mov	_err+0, #0x02
00120$:
;	tbasic.c: 527: value = tmp;
	ldw	x, (0x02, sp)
	jra	00121$
00123$:
;	tbasic.c: 530: if (sign) return -value;
	tnz	(0x01, sp)
	jreq	00125$
	negw	x
;	tbasic.c: 531: return value;
00125$:
;	tbasic.c: 532: }
	addw	sp, #4
	ret
;	tbasic.c: 535: uint8_t toktoi()
;	-----------------------------------------
;	 function toktoi
;	-----------------------------------------
_toktoi:
	sub	sp, #11
;	tbasic.c: 540: uint8_t   len = 0;
	clr	(0x06, sp)
;	tbasic.c: 543: char      *s = lbuf;
	ldw	x, #(_lbuf+0)
	ldw	(0x01, sp), x
;	tbasic.c: 548: while (*s)
00157$:
	ldw	x, (0x01, sp)
	ld	a, (x)
	ld	(0x0b, sp), a
	jrne	00398$
	jp	00159$
00398$:
;	tbasic.c: 550: while (c_isspace(*s)) s++;                // Leerzeichen ueberlesen
	ldw	y, (0x01, sp)
	ldw	(0x0a, sp), y
00101$:
	ldw	x, (0x0a, sp)
	ld	a, (x)
	push	a
	call	_c_isspace
	addw	sp, #1
	tnz	a
	jreq	00206$
	ldw	x, (0x0a, sp)
	incw	x
	ldw	(0x0a, sp), x
	jra	00101$
00206$:
	ldw	y, (0x0a, sp)
	ldw	(0x01, sp), y
;	tbasic.c: 553: for (i = 0; i < SIZE_KWTBL; i++)
	clr	(0x03, sp)
	clr	(0x07, sp)
00160$:
;	tbasic.c: 555: pkw = (char *)kwtbl[i];                  // Schluesselworttabelle
	ld	a, (0x07, sp)
	clrw	x
	ld	xl, a
	sllw	x
	ldw	x, (_kwtbl+0, x)
;	tbasic.c: 559: while ((*pkw != 0) && (*pkw == c_toupper(*ptok)))
	ldw	(0x08, sp), x
	ldw	y, (0x01, sp)
	ldw	(0x0a, sp), y
00105$:
	ldw	x, (0x08, sp)
	ld	a, (x)
	ld	(0x05, sp), a
	jreq	00207$
	ldw	x, (0x0a, sp)
	ld	a, (x)
	push	a
	call	_c_toupper
	addw	sp, #1
	cp	a, (0x05, sp)
	jrne	00207$
;	tbasic.c: 561: pkw++;
	ldw	x, (0x08, sp)
	incw	x
	ldw	(0x08, sp), x
;	tbasic.c: 562: ptok++;
	ldw	x, (0x0a, sp)
	incw	x
	ldw	(0x0a, sp), x
	jra	00105$
00207$:
	ldw	y, (0x08, sp)
	ldw	(0x04, sp), y
;	tbasic.c: 565: if (*pkw == 0)                           // gefunden
	ldw	x, (0x08, sp)
	ld	a, (x)
	jrne	00161$
;	tbasic.c: 567: if (len >= SIZE_IBUF - 1)
	ld	a, (0x06, sp)
	cp	a, #0x27
	jrc	00109$
;	tbasic.c: 569: err = ERR_IBUFOF;
	mov	_err+0, #0x04
;	tbasic.c: 570: return 0;
	clr	a
	jp	00169$
00109$:
;	tbasic.c: 574: ibuf[len++] = i;
	ld	a, (0x06, sp)
	inc	(0x06, sp)
	clrw	x
	ld	xl, a
	ld	a, (0x03, sp)
	ld	((_ibuf+0), x), a
;	tbasic.c: 575: s = ptok;
	ldw	y, (0x0a, sp)
	ldw	(0x01, sp), y
;	tbasic.c: 576: break;
	jra	00112$
00161$:
;	tbasic.c: 553: for (i = 0; i < SIZE_KWTBL; i++)
	inc	(0x07, sp)
	ld	a, (0x07, sp)
	ld	(0x03, sp), a
	cp	a, #0x2a
	jrc	00160$
00112$:
;	tbasic.c: 574: ibuf[len++] = i;
	ld	a, (0x06, sp)
	inc	a
	ld	(0x09, sp), a
;	tbasic.c: 586: if (len >= SIZE_IBUF - 2 - i)
	ld	a, (0x06, sp)
	ld	(0x0b, sp), a
	clr	(0x0a, sp)
;	tbasic.c: 581: if (i == I_REM)
	ld	a, (0x03, sp)
	cp	a, #0x08
	jrne	00123$
;	tbasic.c: 583: while (c_isspace(*s)) s++;               // Leerzeichen
	ldw	x, (0x01, sp)
00113$:
	ld	a, (x)
	pushw	x
	push	a
	call	_c_isspace
	addw	sp, #1
	popw	x
	tnz	a
	jreq	00208$
	incw	x
	jra	00113$
00208$:
	ldw	(0x04, sp), x
;	tbasic.c: 585: for (i = 0; *ptok++; i++);               // Laenge ermitteln
	clr	(0x08, sp)
00163$:
	ld	a, (x)
	incw	x
	tnz	a
	jreq	00116$
	inc	(0x08, sp)
	jra	00163$
00116$:
;	tbasic.c: 586: if (len >= SIZE_IBUF - 2 - i)
	ld	a, (0x08, sp)
	clrw	x
	push	a
	ld	a, #0x26
	sub	a, (1, sp)
	ld	(0x04, sp), a
	ld	a, xl
	neg	a
	ld	(0x03, sp), a
	pop	a
	ldw	x, (0x0a, sp)
	cpw	x, (0x02, sp)
	jrslt	00118$
;	tbasic.c: 588: err = ERR_IBUFOF;
	mov	_err+0, #0x04
;	tbasic.c: 589: return 0;
	clr	a
	jp	00169$
00118$:
;	tbasic.c: 591: ibuf[len++] = i;                         // Laenge setzen
	ld	a, (0x06, sp)
	ld	xl, a
	ld	a, (0x09, sp)
	ld	(0x0b, sp), a
	clr	a
	ld	xh, a
	addw	x, #(_ibuf+0)
	ld	a, (0x08, sp)
	ld	(x), a
;	tbasic.c: 592: while (i--)                              // String kopieren
	ldw	y, (0x04, sp)
	ld	a, (0x08, sp)
	ld	(0x0a, sp), a
00119$:
	ld	a, (0x0a, sp)
	dec	(0x0a, sp)
	tnz	a
	jrne	00416$
	jp	00210$
00416$:
;	tbasic.c: 594: ibuf[len++] = *s++;
	clrw	x
	ld	a, (0x0b, sp)
	ld	xl, a
	addw	x, #(_ibuf+0)
	inc	(0x0b, sp)
	ld	a, (y)
	incw	y
	ld	(x), a
	jra	00119$
;	tbasic.c: 596: break;
00123$:
;	tbasic.c: 599: if (*pkw == 0) continue;
	ldw	x, (0x04, sp)
	ld	a, (x)
	jrne	00417$
	jp	00157$
00417$:
;	tbasic.c: 601: ptok = s;
	ldw	y, (0x01, sp)
	ldw	(0x04, sp), y
;	tbasic.c: 604: if (c_isdigit(*ptok))
	ldw	x, (0x01, sp)
	ld	a, (x)
	push	a
	call	_c_isdigit
	addw	sp, #1
	tnz	a
	jrne	00418$
	jp	00155$
00418$:
;	tbasic.c: 606: value = 0;
	clrw	x
	ldw	(0x0a, sp), x
;	tbasic.c: 608: do
	ldw	y, (0x01, sp)
00128$:
;	tbasic.c: 610: tmp = 10 * value + *ptok++ - '0';
	ldw	x, (0x0a, sp)
	pushw	x
	sllw	x
	sllw	x
	addw	x, (1, sp)
	sllw	x
	addw	sp, #2
	ld	a, (y)
	incw	y
	ld	(0x08, sp), a
	clr	(0x07, sp)
	addw	x, (0x07, sp)
	subw	x, #0x0030
;	tbasic.c: 611: if (value > tmp)
	cpw	x, (0x0a, sp)
	jrsge	00127$
;	tbasic.c: 613: err = ERR_VOF;
	mov	_err+0, #0x02
;	tbasic.c: 614: return 0;
	clr	a
	jp	00169$
00127$:
;	tbasic.c: 616: value = tmp;
	ldw	(0x0a, sp), x
;	tbasic.c: 617: } while (c_isdigit(*ptok));
	ld	a, (y)
	pushw	y
	push	a
	call	_c_isdigit
	addw	sp, #1
	popw	y
	tnz	a
	jrne	00128$
;	tbasic.c: 619: if (len >= SIZE_IBUF - 3)
	ld	a, (0x06, sp)
	cp	a, #0x25
	jrc	00132$
;	tbasic.c: 621: err = ERR_IBUFOF;
	mov	_err+0, #0x04
;	tbasic.c: 622: return 0;
	clr	a
	jp	00169$
00132$:
;	tbasic.c: 624: s = ptok;
	ldw	(0x01, sp), y
;	tbasic.c: 625: ibuf[len++] = I_NUM;
	ld	a, (0x06, sp)
	exg	a, yl
	ld	a, (0x09, sp)
	exg	a, yl
	clrw	x
	ld	xl, a
	ld	a, #0x2a
	ld	((_ibuf+0), x), a
;	tbasic.c: 626: ibuf[len++] = value & 255;
	ldw	x, y
	incw	y
	clr	a
	ld	xh, a
	ld	a, (0x0b, sp)
	ld	((_ibuf+0), x), a
;	tbasic.c: 627: ibuf[len++] = value >> 8;
	ldw	x, y
	ld	a, yl
	inc	a
	ld	(0x06, sp), a
	clr	a
	ld	xh, a
	addw	x, #(_ibuf+0)
	ldw	y, (0x0a, sp)
	clr	a
	tnzw	y
	jrpl	00422$
	dec	a
00422$:
	rrwa	y
	ld	a, yl
	ld	(x), a
	jp	00157$
00155$:
;	tbasic.c: 548: while (*s)
	ldw	x, (0x01, sp)
	ld	a, (x)
;	tbasic.c: 633: c = *s++;
	ldw	x, (0x01, sp)
	incw	x
	ldw	(0x07, sp), x
;	tbasic.c: 631: if (*s == '\"' || *s == '\'')
	cp	a, #0x22
	jreq	00150$
	cp	a, #0x27
	jreq	00428$
	jp	00151$
00428$:
00150$:
;	tbasic.c: 633: c = *s++;
	ldw	y, (0x07, sp)
	ldw	(0x02, sp), y
	ld	(0x07, sp), a
;	tbasic.c: 635: for (i = 0; (*ptok != c) && c_isprint(*ptok); i++) ptok++;
	ldw	y, (0x02, sp)
	ldw	(0x04, sp), y
	clr	(0x08, sp)
00167$:
	ldw	x, (0x04, sp)
	ld	a, (x)
	cp	a, (0x07, sp)
	jreq	00133$
	push	a
	call	_c_isprint
	addw	sp, #1
	tnz	a
	jreq	00133$
	ldw	x, (0x04, sp)
	incw	x
	ldw	(0x04, sp), x
	inc	(0x08, sp)
	jra	00167$
00133$:
;	tbasic.c: 637: if (len >= SIZE_IBUF - 1 - i)
	ld	a, (0x08, sp)
	clrw	x
	push	a
	ld	a, #0x27
	sub	a, (1, sp)
	ld	(0x06, sp), a
	ld	a, xl
	neg	a
	ld	(0x05, sp), a
	pop	a
	ldw	x, (0x0a, sp)
	cpw	x, (0x04, sp)
	jrslt	00135$
;	tbasic.c: 639: err = ERR_IBUFOF;
	mov	_err+0, #0x04
;	tbasic.c: 640: return 0;
	clr	a
	jp	00169$
00135$:
;	tbasic.c: 643: ibuf[len++] = I_STR;
	ld	a, (0x06, sp)
	exg	a, yl
	ld	a, (0x09, sp)
	exg	a, yl
	clrw	x
	ld	xl, a
	ld	a, #0x2c
	ld	((_ibuf+0), x), a
;	tbasic.c: 644: ibuf[len++] = i;
	ldw	x, y
	ld	a, yl
	inc	a
	rlwa	x
	clr	a
	rrwa	x
	addw	x, #(_ibuf+0)
	push	a
	ld	a, (0x09, sp)
	ld	(x), a
	pop	a
;	tbasic.c: 646: while (i--)
	ldw	y, (0x02, sp)
	ldw	(0x0a, sp), y
00136$:
	push	a
	ld	a, (0x09, sp)
	ld	(0x07, sp), a
	pop	a
	dec	(0x08, sp)
;	tbasic.c: 648: ibuf[len++] = *s++;
	ldw	x, (0x0a, sp)
	incw	x
	ldw	(0x04, sp), x
	ldw	x, (0x0a, sp)
	push	a
	ld	a, (x)
	ld	(0x0a, sp), a
	pop	a
;	tbasic.c: 646: while (i--)
	tnz	(0x06, sp)
	jreq	00212$
;	tbasic.c: 648: ibuf[len++] = *s++;
	ld	xl, a
	inc	a
	rlwa	x
	clr	a
	rrwa	x
	addw	x, #(_ibuf+0)
	ldw	y, (0x04, sp)
	ldw	(0x0a, sp), y
	push	a
	ld	a, (0x0a, sp)
	ld	(x), a
	pop	a
	jra	00136$
00212$:
	ld	(0x06, sp), a
	ldw	y, (0x0a, sp)
	ldw	(0x01, sp), y
;	tbasic.c: 650: if (*s == c) s++;
	ld	a, (0x09, sp)
	cp	a, (0x07, sp)
	jreq	00438$
	jp	00157$
00438$:
	ldw	y, (0x04, sp)
	ldw	(0x01, sp), y
	jp	00157$
00151$:
;	tbasic.c: 654: if (c_isalpha(*ptok))
	push	a
	call	_c_isalpha
	addw	sp, #1
	tnz	a
	jreq	00148$
;	tbasic.c: 656: if (len >= SIZE_IBUF - 2)
	ld	a, (0x06, sp)
	cp	a, #0x26
	jrc	00142$
;	tbasic.c: 658: err = ERR_IBUFOF;
	mov	_err+0, #0x04
;	tbasic.c: 659: return 0;
	clr	a
	jra	00169$
00142$:
;	tbasic.c: 661: if (len >= 4 && ibuf[len - 2] == I_VAR && ibuf[len - 4] == I_VAR)
	ld	a, (0x06, sp)
	cp	a, #0x04
	jrc	00144$
	ld	(0x0b, sp), a
	sub	a, #0x02
	ld	xl, a
	rlc	a
	clr	a
	sbc	a, #0x00
	ld	xh, a
	ld	a, (_ibuf+0, x)
	cp	a, #0x2b
	jrne	00144$
	ld	a, (0x0b, sp)
	sub	a, #0x04
	ld	xl, a
	rlc	a
	clr	a
	sbc	a, #0x00
	ld	xh, a
	ld	a, (_ibuf+0, x)
	cp	a, #0x2b
	jrne	00144$
;	tbasic.c: 663: err = ERR_SYNTAX;
	mov	_err+0, #0x14
;	tbasic.c: 664: return 0;
	clr	a
	jra	00169$
00144$:
;	tbasic.c: 666: ibuf[len++] = I_VAR;
	ld	a, (0x06, sp)
	exg	a, yl
	ld	a, (0x09, sp)
	exg	a, yl
	clrw	x
	ld	xl, a
	ld	a, #0x2b
	ld	((_ibuf+0), x), a
;	tbasic.c: 667: ibuf[len++] = c_toupper(*ptok) - 'A';
	ldw	x, y
	ld	a, yl
	inc	a
	ld	(0x06, sp), a
	clr	a
	ld	xh, a
	addw	x, #(_ibuf+0)
	ldw	y, (0x04, sp)
	ld	a, (y)
	pushw	x
	push	a
	call	_c_toupper
	addw	sp, #1
	popw	x
	sub	a, #0x41
	ld	(x), a
;	tbasic.c: 668: s++;
	ldw	y, (0x07, sp)
	ldw	(0x01, sp), y
	jp	00157$
00148$:
;	tbasic.c: 672: err = ERR_SYNTAX;
	mov	_err+0, #0x14
;	tbasic.c: 673: return 0;
	clr	a
	jra	00169$
00210$:
	ld	a, (0x0b, sp)
	ld	(0x06, sp), a
00159$:
;	tbasic.c: 678: ibuf[len++] = I_EOL;
	ld	a, (0x06, sp)
	ld	xl, a
	inc	a
	rlwa	x
	clr	a
	rrwa	x
	addw	x, #(_ibuf+0)
	push	a
	ld	a, #0x2d
	ld	(x), a
	pop	a
;	tbasic.c: 679: return len;
00169$:
;	tbasic.c: 680: }
	addw	sp, #11
	ret
;	tbasic.c: 682: int16_t getlineno(uint8_t *lp)
;	-----------------------------------------
;	 function getlineno
;	-----------------------------------------
_getlineno:
	sub	sp, #4
;	tbasic.c: 684: if (*lp == 0) return 32767;                      // hoechste Zeilennummer
	ldw	y, (0x07, sp)
	ld	a, (y)
	jrne	00102$
	ldw	x, #0x7fff
	jra	00103$
00102$:
;	tbasic.c: 685: return *(lp + 1) | *(lp + 2) << 8;
	ldw	x, y
	ld	a, (0x1, x)
	ld	xl, a
	ld	a, (0x2, y)
	clr	(0x03, sp)
	clr	(0x02, sp)
	clr	(0x03, sp)
	or	a, (0x03, sp)
	rrwa	x
	or	a, (0x02, sp)
	ld	xl, a
00103$:
;	tbasic.c: 686: }
	addw	sp, #4
	ret
;	tbasic.c: 688: uint8_t* getlp(int16_t lineno)
;	-----------------------------------------
;	 function getlp
;	-----------------------------------------
_getlp:
	pushw	x
;	tbasic.c: 693: for (lp = listbuf; *lp; lp += *lp)
	ldw	x, #_listbuf+0
00105$:
	ld	a, (x)
	jreq	00103$
;	tbasic.c: 695: if (getlineno(lp) >= lineno) break;
	pushw	x
	pushw	x
	call	_getlineno
	addw	sp, #2
	ldw	(0x03, sp), x
	cpw	x, (0x07, sp)
	popw	x
	jrsge	00103$
;	tbasic.c: 693: for (lp = listbuf; *lp; lp += *lp)
	ld	a, (x)
	pushw	x
	add	a, (2, sp)
	popw	x
	ld	xl, a
	clr	a
	pushw	x
	adc	a, (1, sp)
	popw	x
	ld	xh, a
	jra	00105$
00103$:
;	tbasic.c: 697: return lp;
;	tbasic.c: 698: }
	addw	sp, #2
	ret
;	tbasic.c: 700: int16_t getsize(void)
;	-----------------------------------------
;	 function getsize
;	-----------------------------------------
_getsize:
	pushw	x
;	tbasic.c: 705: for (lp = listbuf; *lp; lp += *lp);
	ldw	x, #(_listbuf+0)
00103$:
	ld	a, (x)
	jreq	00101$
	pushw	x
	add	a, (2, sp)
	popw	x
	ld	xl, a
	clr	a
	pushw	x
	adc	a, (1, sp)
	popw	x
	ld	xh, a
	jra	00103$
00101$:
;	tbasic.c: 706: return (int16_t)listbuf + SIZE_LIST - lp - 1;
	ldw	(0x01, sp), x
	ldw	x, #0x01ff
	subw	x, (0x01, sp)
	ldw	y, #(_listbuf+0)
	ldw	(0x01, sp), y
	addw	x, (0x01, sp)
;	tbasic.c: 707: }
	addw	sp, #2
	ret
;	tbasic.c: 709: void inslist(void)
;	-----------------------------------------
;	 function inslist
;	-----------------------------------------
_inslist:
	sub	sp, #12
;	tbasic.c: 716: if (getsize() < *ibuf)
	call	_getsize
	ld	a, _ibuf+0
	ld	(0x0c, sp), a
	clr	(0x0b, sp)
	cpw	x, (0x0b, sp)
	jrsge	00102$
;	tbasic.c: 718: err = ERR_LBUFOF;                       // List Speicher overflow
	mov	_err+0, #0x05
;	tbasic.c: 719: return;
	jp	00123$
00102$:
;	tbasic.c: 722: insp = getlp(getlineno(ibuf));
	push	#<(_ibuf+0)
	push	#((_ibuf+0) >> 8)
	call	_getlineno
	addw	sp, #2
	pushw	x
	call	_getlp
	addw	sp, #2
;	tbasic.c: 724: if (getlineno(insp) == getlineno(ibuf))    // Zeilennummer
	ldw	(0x01, sp), x
	pushw	x
	call	_getlineno
	addw	sp, #2
	ldw	(0x0b, sp), x
	push	#<(_ibuf+0)
	push	#((_ibuf+0) >> 8)
	call	_getlineno
	addw	sp, #2
	cpw	x, (0x0b, sp)
	jrne	00110$
;	tbasic.c: 726: p1 = insp;
	ldw	y, (0x01, sp)
	ldw	(0x03, sp), y
;	tbasic.c: 727: p2 = p1 + *p1;
	ldw	x, (0x01, sp)
	ld	a, (x)
	clrw	x
	ld	xl, a
	addw	x, (0x01, sp)
;	tbasic.c: 728: while ((len = *p2) != 0)
00106$:
	ld	a, (x)
	ld	(0x0a, sp), a
	clr	(0x09, sp)
	ldw	y, (0x09, sp)
	ldw	(0x0b, sp), y
	ldw	y, (0x09, sp)
	jreq	00108$
;	tbasic.c: 730: while (len--) *p1++ = *p2++;
	ldw	(0x07, sp), x
	ldw	y, (0x03, sp)
	ldw	(0x09, sp), y
00103$:
	ldw	y, (0x0b, sp)
	ldw	(0x05, sp), y
	ldw	y, (0x0b, sp)
	decw	y
	ldw	(0x0b, sp), y
	ldw	y, (0x05, sp)
	jreq	00106$
	ldw	x, (0x07, sp)
	ld	a, (x)
	ldw	x, (0x07, sp)
	incw	x
	ldw	(0x07, sp), x
	ldw	y, (0x09, sp)
	ld	(y), a
	ldw	y, (0x09, sp)
	incw	y
	ldw	(0x09, sp), y
	ldw	(0x03, sp), y
	jra	00103$
00108$:
;	tbasic.c: 732: *p1 = 0;
	ldw	x, (0x03, sp)
	clr	(x)
00110$:
;	tbasic.c: 735: if (*ibuf == 4) return;
	ld	a, _ibuf+0
	cp	a, #0x04
	jreq	00123$
;	tbasic.c: 738: for (p1 = insp; *p1; p1 += *p1);
	ldw	y, (0x01, sp)
	ldw	(0x0b, sp), y
00121$:
	ldw	x, (0x0b, sp)
	push	a
	ld	a, (x)
	ld	xl, a
	pop	a
	exg	a, xl
	tnz	a
	exg	a, xl
	jreq	00113$
	rlwa	x
	clr	a
	rrwa	x
	addw	x, (0x0b, sp)
	ldw	(0x0b, sp), x
	jra	00121$
00113$:
;	tbasic.c: 739: len = p1 - insp + 1;
	ldw	x, (0x0b, sp)
	subw	x, (0x01, sp)
	incw	x
	ldw	(0x07, sp), x
;	tbasic.c: 740: p2 = p1 + *ibuf;
	clrw	x
	ld	xl, a
	addw	x, (0x0b, sp)
;	tbasic.c: 741: while (len--) *p2-- = *p1--;
	ldw	y, (0x0b, sp)
	ldw	(0x09, sp), y
	ldw	(0x0b, sp), x
	ldw	y, (0x07, sp)
00114$:
	ldw	(0x07, sp), y
	decw	y
	ldw	x, (0x07, sp)
	jreq	00116$
	ldw	x, (0x09, sp)
	ld	a, (x)
	ldw	x, (0x09, sp)
	decw	x
	ldw	(0x09, sp), x
	ldw	x, (0x0b, sp)
	ld	(x), a
	ldw	x, (0x0b, sp)
	decw	x
	ldw	(0x0b, sp), x
	jra	00114$
00116$:
;	tbasic.c: 744: len = *ibuf;
	ld	a, _ibuf+0
	clrw	x
	ld	xl, a
	exgw	x, y
;	tbasic.c: 746: p2 = ibuf;
;	tbasic.c: 747: while (len--) *p1++ = *p2++;
	ldw	x, #(_ibuf+0)
	ldw	(0x09, sp), x
	ldw	x, (0x01, sp)
	ldw	(0x0b, sp), x
00117$:
	ldw	x, y
	decw	y
	tnzw	x
	jreq	00123$
	ldw	x, (0x09, sp)
	ld	a, (x)
	ldw	x, (0x09, sp)
	incw	x
	ldw	(0x09, sp), x
	ldw	x, (0x0b, sp)
	ld	(x), a
	ldw	x, (0x0b, sp)
	incw	x
	ldw	(0x0b, sp), x
	jra	00117$
00123$:
;	tbasic.c: 748: }
	addw	sp, #12
	ret
;	tbasic.c: 750: void putlist(uint8_t* ip)
;	-----------------------------------------
;	 function putlist
;	-----------------------------------------
_putlist:
	sub	sp, #6
;	tbasic.c: 754: while (*ip != I_EOL)
00132$:
	ldw	y, (0x09, sp)
	ldw	(0x01, sp), y
	ldw	x, y
	ld	a, (x)
	ld	(0x06, sp), a
	cp	a, #0x2d
	jrne	00233$
	jp	00138$
00233$:
;	tbasic.c: 763: ip++;
	ldw	x, (0x01, sp)
	incw	x
	ldw	(0x03, sp), x
;	tbasic.c: 757: if (*ip < SIZE_KWTBL)
	ld	a, (0x06, sp)
	cp	a, #0x2a
	jrnc	00130$
;	tbasic.c: 759: uart_putstring((char *)kwtbl[*ip]);
	ld	a, (0x06, sp)
	clrw	x
	ld	xl, a
	sllw	x
	ldw	x, (_kwtbl+0, x)
	pushw	x
	call	_uart_putstring
	popw	x
;	tbasic.c: 760: if (!nospacea(*ip))  uart_putchar(' ');
	ldw	x, (0x01, sp)
	ld	a, (x)
	push	#0x16
	push	#<(_i_nsa+0)
	push	#((_i_nsa+0) >> 8)
	push	a
	call	_sstyle
	addw	sp, #4
	tnz	a
	jrne	00102$
	push	#0x20
	call	_uart_putchar
	pop	a
00102$:
;	tbasic.c: 761: if (*ip == I_REM)
	ldw	x, (0x01, sp)
	ld	a, (x)
	cp	a, #0x08
	jrne	00107$
;	tbasic.c: 763: ip++;
	ldw	y, (0x03, sp)
;	tbasic.c: 764: i = *ip++;
	ldw	(0x09, sp), y
	ldw	x, y
	ld	a, (x)
	ld	(0x04, sp), a
	incw	x
;	tbasic.c: 765: while (i--)
	ldw	(0x09, sp), x
	ldw	(0x05, sp), x
00103$:
	ld	a, (0x04, sp)
	dec	(0x04, sp)
	tnz	a
	jrne	00240$
	jp	00138$
00240$:
;	tbasic.c: 767: uart_putchar(*ip++);
	ldw	x, (0x05, sp)
	ld	a, (x)
	ldw	x, (0x05, sp)
	incw	x
	ldw	(0x05, sp), x
	push	a
	call	_uart_putchar
	pop	a
;	tbasic.c: 769: return;
	jra	00103$
00107$:
;	tbasic.c: 771: ip++;
	ldw	y, (0x03, sp)
	ldw	(0x09, sp), y
	jra	00132$
00130$:
;	tbasic.c: 776: if (*ip == I_NUM)
	ld	a, (0x06, sp)
	cp	a, #0x2a
	jrne	00127$
;	tbasic.c: 778: ip++;
	ldw	y, (0x03, sp)
;	tbasic.c: 779: putnum(*ip | *(ip + 1) << 8, 0);
	ldw	(0x09, sp), y
	ldw	(0x01, sp), y
	ldw	x, y
	ld	a, (x)
	ld	yl, a
	ldw	x, (0x01, sp)
	ld	a, (0x1, x)
	clr	(0x04, sp)
	clr	(0x05, sp)
	or	a, (0x05, sp)
	ld	xh, a
	ld	a, yl
	or	a, (0x04, sp)
	ld	xl, a
	push	#0x00
	push	#0x00
	pushw	x
	call	_putnum
	addw	sp, #4
;	tbasic.c: 780: ip += 2;
	ldw	x, (0x01, sp)
	incw	x
	incw	x
;	tbasic.c: 781: if (!nospaceb(*ip)) uart_putchar(' ');
	ldw	(0x09, sp), x
	ld	a, (x)
	push	#0x0f
	push	#<(_i_nsb+0)
	push	#((_i_nsb+0) >> 8)
	push	a
	call	_sstyle
	addw	sp, #4
	tnz	a
	jreq	00245$
	jp	00132$
00245$:
	push	#0x20
	call	_uart_putchar
	pop	a
	jp	00132$
00127$:
;	tbasic.c: 786: if (*ip == I_VAR)
	ld	a, (0x06, sp)
	cp	a, #0x2b
	jrne	00124$
;	tbasic.c: 788: ip++;
	ldw	y, (0x03, sp)
;	tbasic.c: 789: uart_putchar(*ip++ + 'A');
	ldw	(0x09, sp), y
	ldw	x, y
	ld	a, (x)
	incw	x
	ldw	(0x09, sp), x
	add	a, #0x41
	push	a
	call	_uart_putchar
	pop	a
;	tbasic.c: 790: if (!nospaceb(*ip)) uart_putchar(' ');
	ldw	x, (0x09, sp)
	ld	a, (x)
	push	#0x0f
	push	#<(_i_nsb+0)
	push	#((_i_nsb+0) >> 8)
	push	a
	call	_sstyle
	addw	sp, #4
	tnz	a
	jreq	00249$
	jp	00132$
00249$:
	push	#0x20
	call	_uart_putchar
	pop	a
	jp	00132$
00124$:
;	tbasic.c: 795: if (*ip == I_STR)
	ld	a, (0x06, sp)
	cp	a, #0x2c
	jrne	00121$
;	tbasic.c: 799: c = '\"';
	ld	a, #0x22
	ld	(0x05, sp), a
;	tbasic.c: 800: ip++;
	ldw	y, (0x03, sp)
;	tbasic.c: 754: while (*ip != I_EOL)
	ldw	(0x09, sp), y
	ldw	x, y
;	tbasic.c: 801: for (i = *ip; i; i--)
	ld	a, (x)
	ld	(0x06, sp), a
00136$:
	tnz	(0x06, sp)
	jreq	00114$
;	tbasic.c: 803: if (*(ip + i) == '\"')
	clrw	y
	ld	a, (0x06, sp)
	ld	yl, a
	addw	y, (0x09, sp)
	ld	a, (y)
	cp	a, #0x22
	jrne	00137$
;	tbasic.c: 805: c = '\'';
	ld	a, #0x27
	ld	(0x05, sp), a
;	tbasic.c: 806: break;
	jra	00114$
00137$:
;	tbasic.c: 801: for (i = *ip; i; i--)
	dec	(0x06, sp)
	jra	00136$
00114$:
;	tbasic.c: 810: uart_putchar(c);
	pushw	x
	ld	a, (0x07, sp)
	push	a
	call	_uart_putchar
	pop	a
	popw	x
;	tbasic.c: 811: i = *ip++;
	ld	a, (x)
	ld	(0x06, sp), a
	incw	x
;	tbasic.c: 812: while (i--)
	ldw	(0x09, sp), x
00115$:
	ld	a, (0x06, sp)
	dec	(0x06, sp)
	tnz	a
	jreq	00159$
;	tbasic.c: 814: uart_putchar(*ip++);
	ld	a, (x)
	incw	x
	pushw	x
	push	a
	call	_uart_putchar
	pop	a
	popw	x
	jra	00115$
00159$:
	ldw	(0x09, sp), x
;	tbasic.c: 816: uart_putchar(c);
	pushw	x
	ld	a, (0x07, sp)
	push	a
	call	_uart_putchar
	pop	a
	popw	x
;	tbasic.c: 817: if (*ip == I_VAR) uart_putchar(' ');
	ld	a, (x)
	cp	a, #0x2b
	jreq	00260$
	jp	00132$
00260$:
	push	#0x20
	call	_uart_putchar
	pop	a
	jp	00132$
00121$:
;	tbasic.c: 823: err = ERR_SYS;
	mov	_err+0, #0x15
;	tbasic.c: 824: return;
00138$:
;	tbasic.c: 830: }
	addw	sp, #6
	ret
;	tbasic.c: 832: int16_t getparam(void)
;	-----------------------------------------
;	 function getparam
;	-----------------------------------------
_getparam:
;	tbasic.c: 837: if (*cip != I_OPEN)
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x13
	jreq	00102$
;	tbasic.c: 839: err = ERR_PAREN;
	mov	_err+0, #0x11
;	tbasic.c: 840: return 0;
	clrw	x
	ret
00102$:
;	tbasic.c: 842: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 843: value = iexp();
	call	_iexp
	exgw	x, y
;	tbasic.c: 844: if (err) return 0;
	tnz	_err+0
	jreq	00104$
	clrw	x
	ret
00104$:
;	tbasic.c: 846: if (*cip != I_CLOSE)
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x14
	jreq	00106$
;	tbasic.c: 848: err = ERR_PAREN;
	mov	_err+0, #0x11
;	tbasic.c: 849: return 0;
	clrw	x
	ret
00106$:
;	tbasic.c: 851: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 853: return value;
	ldw	x, y
;	tbasic.c: 854: }
	ret
;	tbasic.c: 856: void get_port(PB *pb, uint8_t index)
;	-----------------------------------------
;	 function get_port
;	-----------------------------------------
_get_port:
;	tbasic.c: 858: pb->p = portmap[index];
	ldw	y, (0x03, sp)
	clrw	x
	ld	a, (0x05, sp)
	ld	xl, a
	ld	a, (_portmap+0, x)
	ld	(y), a
;	tbasic.c: 859: pb->b = pinmap[index];
	incw	y
	clrw	x
	ld	a, (0x05, sp)
	ld	xl, a
	ld	a, (_pinmap+0, x)
	ld	(y), a
;	tbasic.c: 860: }
	ret
;	tbasic.c: 866: uint8_t *io_adr(uint8_t ioport)
;	-----------------------------------------
;	 function io_adr
;	-----------------------------------------
_io_adr:
;	tbasic.c: 868: return (uint8_t *)0x5000 + (ioport * 5);
	ld	a, (0x03, sp)
	clrw	x
	ld	xl, a
	pushw	x
	sllw	x
	sllw	x
	addw	x, (1, sp)
	addw	sp, #2
	addw	x, #0x5000
;	tbasic.c: 869: }
	ret
;	tbasic.c: 875: uint8_t io_get(uint8_t ioport, uint8_t iono)
;	-----------------------------------------
;	 function io_get
;	-----------------------------------------
_io_get:
	push	a
;	tbasic.c: 877: uint8_t *ioadr = io_adr(ioport);  
	ld	a, (0x04, sp)
	push	a
	call	_io_adr
	pop	a
;	tbasic.c: 880: ioadr = io_adr(ioport);
	ld	a, (0x04, sp)
	push	a
	call	_io_adr
	pop	a
;	tbasic.c: 881: b =  ( *(ioadr + P_IDR) & (1 << iono) ) >> iono;
	ld	a, (0x1, x)
	ld	yl, a
	ld	a, (0x05, sp)
	ld	(0x01, sp), a
	clrw	x
	incw	x
	ld	a, (0x01, sp)
	jreq	00104$
00103$:
	sllw	x
	dec	a
	jrne	00103$
00104$:
	clr	a
	pushw	x
	and	a, (1, sp)
	popw	x
	ld	xh, a
	pushw	x
	ld	a, yl
	and	a, (2, sp)
	popw	x
	ld	xl, a
	ld	a, (0x01, sp)
	jreq	00106$
00105$:
	sraw	x
	dec	a
	jrne	00105$
00106$:
	ld	a, xl
;	tbasic.c: 882: return  b;
;	tbasic.c: 883: }
	addw	sp, #1
	ret
;	tbasic.c: 896: void io_set(uint8_t ioport, uint8_t iono, uint8_t value)
;	-----------------------------------------
;	 function io_set
;	-----------------------------------------
_io_set:
	push	a
;	tbasic.c: 898: uint8_t *ioadr = io_adr(ioport);  
	ld	a, (0x04, sp)
	push	a
	call	_io_adr
	pop	a
;	tbasic.c: 901: b= 1 << iono;
	ld	a, (0x05, sp)
	ld	(0x01, sp), a
	ld	a, #0x01
	push	a
	ld	a, (0x02, sp)
	jreq	00112$
00111$:
	sll	(1, sp)
	dec	a
	jrne	00111$
00112$:
	ld	a, (x)
	ld	(0x02, sp), a
	pop	a
	tnz	(0x06, sp)
	jreq	00102$
	or	a, (0x01, sp)
	ld	(x), a
	jra	00104$
00102$:
	cpl	a
	and	a, (0x01, sp)
	ld	(x), a
00104$:
;	tbasic.c: 903: }
	pop	a
	ret
;	tbasic.c: 909: uint8_t io_bitset(uint8_t ioport, uint8_t iono)
;	-----------------------------------------
;	 function io_bitset
;	-----------------------------------------
_io_bitset:
	push	a
;	tbasic.c: 911: uint8_t *ioadr = io_adr(ioport);    
	ld	a, (0x04, sp)
	push	a
	call	_io_adr
	pop	a
;	tbasic.c: 914: b=  ( *(ioadr + P_IDR) & (1 << iono) ) >> iono;
	ld	a, (0x1, x)
	ld	yl, a
	ld	a, (0x05, sp)
	ld	(0x01, sp), a
	clrw	x
	incw	x
	ld	a, (0x01, sp)
	jreq	00104$
00103$:
	sllw	x
	dec	a
	jrne	00103$
00104$:
	clr	a
	pushw	x
	and	a, (1, sp)
	popw	x
	ld	xh, a
	pushw	x
	ld	a, yl
	and	a, (2, sp)
	popw	x
	ld	xl, a
	ld	a, (0x01, sp)
	jreq	00106$
00105$:
	sraw	x
	dec	a
	jrne	00105$
00106$:
	ld	a, xl
;	tbasic.c: 916: return  b;
;	tbasic.c: 918: }
	addw	sp, #1
	ret
;	tbasic.c: 947: void io_outputinit(uint8_t ioport, uint8_t iono)
;	-----------------------------------------
;	 function io_outputinit
;	-----------------------------------------
_io_outputinit:
	pushw	x
;	tbasic.c: 949: uint8_t *ioadr = io_adr(ioport);  
	ld	a, (0x05, sp)
	push	a
	call	_io_adr
	pop	a
	exgw	x, y
;	tbasic.c: 953: b= 1 << iono;
	ld	a, (0x06, sp)
	push	a
	ld	a, #0x01
	ld	(0x02, sp), a
	pop	a
	tnz	a
	jreq	00104$
00103$:
	sll	(0x01, sp)
	dec	a
	jrne	00103$
00104$:
;	tbasic.c: 954: *(ioadr + P_DDR) |=  b;        // Output Register
	ldw	x, y
	incw	x
	incw	x
	ld	a, (x)
	or	a, (0x01, sp)
	ld	(x), a
;	tbasic.c: 955: *(ioadr + P_CR1) |=  b;        // Controll Register 1
	ldw	x, y
	addw	x, #0x0003
	ld	a, (x)
	or	a, (0x01, sp)
	ld	(x), a
;	tbasic.c: 956: *(ioadr + P_CR2) &= ~(b);      // Controll Register 2
	ldw	x, y
	addw	x, #0x0004
	ld	a, (x)
	ld	(0x02, sp), a
	ld	a, (0x01, sp)
	cpl	a
	and	a, (0x02, sp)
	ld	(x), a
;	tbasic.c: 957: }
	popw	x
	ret
;	tbasic.c: 964: void ibyteout(uint8_t value)
;	-----------------------------------------
;	 function ibyteout
;	-----------------------------------------
_ibyteout:
	sub	sp, #7
;	tbasic.c: 969: for (b= 0; b< 8; b++)
	ldw	x, sp
	incw	x
	incw	x
	ldw	(0x03, sp), x
	clr	(0x07, sp)
00102$:
;	tbasic.c: 971: get_port(&pb, b);
	ldw	x, sp
	incw	x
	ld	a, (0x07, sp)
	push	a
	pushw	x
	call	_get_port
	addw	sp, #3
;	tbasic.c: 972: io_outputinit(pb.p, pb.b);
	ldw	x, (0x03, sp)
	ld	a, (x)
	ld	xl, a
	ld	a, (0x01, sp)
	pushw	x
	addw	sp, #1
	push	a
	call	_io_outputinit
	popw	x
;	tbasic.c: 973: delay_us(5);
	push	#0x05
	push	#0x00
	call	_delay_us
	popw	x
;	tbasic.c: 974: v = testbit16(value, b);
	clrw	x
	incw	x
	ld	a, (0x07, sp)
	jreq	00113$
00112$:
	sllw	x
	dec	a
	jrne	00112$
00113$:
	ld	a, (0x0a, sp)
	ld	(0x06, sp), a
	clr	(0x05, sp)
	ld	a, xl
	and	a, (0x06, sp)
	rlwa	x
	and	a, (0x05, sp)
	ld	xh, a
	ld	a, (0x07, sp)
	jreq	00115$
00114$:
	sraw	x
	dec	a
	jrne	00114$
00115$:
	ld	a, xl
;	tbasic.c: 975: io_set(pb.p, pb.b, !v);
	sub	a, #0x01
	clr	a
	rlc	a
	ld	xl, a
	ldw	y, (0x03, sp)
	ld	a, (y)
	rlwa	x
	ld	a, (0x01, sp)
	rrwa	x
	pushw	x
	addw	sp, #1
	push	a
	ld	a, xh
	push	a
	call	_io_set
	addw	sp, #3
;	tbasic.c: 969: for (b= 0; b< 8; b++)
	inc	(0x07, sp)
	ld	a, (0x07, sp)
	cp	a, #0x08
	jrc	00102$
;	tbasic.c: 977: }
	addw	sp, #7
	ret
;	tbasic.c: 984: void io_inputinit(uint8_t ioport, uint8_t iono)
;	-----------------------------------------
;	 function io_inputinit
;	-----------------------------------------
_io_inputinit:
	pushw	x
;	tbasic.c: 986: uint8_t *ioadr = io_adr(ioport);  
	ld	a, (0x05, sp)
	push	a
	call	_io_adr
	pop	a
	exgw	x, y
;	tbasic.c: 989: b= 1 << iono;
	ld	a, (0x06, sp)
	push	a
	ld	a, #0x01
	ld	(0x02, sp), a
	pop	a
	tnz	a
	jreq	00104$
00103$:
	sll	(0x01, sp)
	dec	a
	jrne	00103$
00104$:
;	tbasic.c: 990: *(ioadr + P_DDR) &= ~(b);        // Output Register
	ldw	x, y
	incw	x
	incw	x
	ld	a, (x)
	ld	(0x02, sp), a
	ld	a, (0x01, sp)
	cpl	a
	and	a, (0x02, sp)
	ld	(x), a
;	tbasic.c: 991: *(ioadr + P_CR1) |= b;           // Controll Register 1
	ldw	x, y
	addw	x, #0x0003
	ld	a, (x)
	or	a, (0x01, sp)
	ld	(x), a
;	tbasic.c: 992: }
	popw	x
	ret
;	tbasic.c: 1003: int16_t iioin(int16_t index)
;	-----------------------------------------
;	 function iioin
;	-----------------------------------------
_iioin:
	sub	sp, #6
;	tbasic.c: 1006: get_port(&pb, index);
	ld	a, (0x0a, sp)
	push	a
	ldw	x, sp
	incw	x
	incw	x
	pushw	x
	call	_get_port
	addw	sp, #3
;	tbasic.c: 1010: if (testbit16(portddr, index))
	ld	a, (0x0a, sp)
	clrw	x
	incw	x
	tnz	a
	jreq	00111$
00110$:
	sllw	x
	dec	a
	jrne	00110$
00111$:
	ldw	y, _portddr+0
	ldw	(0x03, sp), y
	ld	a, xl
	and	a, (0x04, sp)
	ld	yl, a
	ld	a, xh
	and	a, (0x03, sp)
	ld	yh, a
	ld	a, (0x0a, sp)
	jreq	00113$
00112$:
	srlw	y
	dec	a
	jrne	00112$
00113$:
;	tbasic.c: 1013: io_inputinit(pb.p, pb.b);
	pushw	x
	ldw	x, sp
	addw	x, #4
	ldw	(0x07, sp), x
	popw	x
;	tbasic.c: 1010: if (testbit16(portddr, index))
	tnzw	y
	jreq	00102$
;	tbasic.c: 1012: bitclr16(portddr, index);
	cplw	x
	ld	a, xl
	and	a, (0x04, sp)
	rlwa	x
	and	a, (0x03, sp)
	ld	xh, a
	ldw	_portddr+0, x
;	tbasic.c: 1013: io_inputinit(pb.p, pb.b);
	ldw	x, (0x05, sp)
	ld	a, (x)
	ld	xl, a
	ld	a, (0x01, sp)
	pushw	x
	addw	sp, #1
	push	a
	call	_io_inputinit
	popw	x
00102$:
;	tbasic.c: 1016: return io_get(pb.p, pb.b);
	ldw	x, (0x05, sp)
	ld	a, (x)
	ld	xl, a
	ld	a, (0x01, sp)
	pushw	x
	addw	sp, #1
	push	a
	call	_io_get
	popw	x
	clrw	x
	ld	xl, a
;	tbasic.c: 1017: }
	addw	sp, #6
	ret
;	tbasic.c: 1045: uint16_t adc_read(void)
;	-----------------------------------------
;	 function adc_read
;	-----------------------------------------
_adc_read:
	pushw	x
;	tbasic.c: 1049: ADC_CR1 |= ADC_CR1_ADON;            // AD-Wandlung starten
	bset	21505, #0
;	tbasic.c: 1050: while (!(ADC_CSR & ADC_CSR_EOX));   // warten bis Conversion beendet
00101$:
	ld	a, 0x5400
	jrpl	00101$
;	tbasic.c: 1051: delay_us(5);                        // Warten bis Wert gelesen werden kann
	push	#0x05
	push	#0x00
	call	_delay_us
	popw	x
;	tbasic.c: 1053: adcvalue = (ADC_DRH << 2);          // die unteren 2 Bit
	ld	a, 0x5404
	clrw	x
	ld	xl, a
	sllw	x
	sllw	x
	exgw	x, y
;	tbasic.c: 1054: adcvalue += ADC_DRL;                // die oberen 8 Bit
	ld	a, 0x5405
	clrw	x
	ldw	(0x01, sp), y
	ld	xl, a
	addw	x, (0x01, sp)
;	tbasic.c: 1056: return adcvalue;
;	tbasic.c: 1057: }
	addw	sp, #2
	ret
;	tbasic.c: 1068: void ioutput()
;	-----------------------------------------
;	 function ioutput
;	-----------------------------------------
_ioutput:
	sub	sp, #10
;	tbasic.c: 1077: index = getparam();
	call	_getparam
	ldw	(0x09, sp), x
;	tbasic.c: 1078: if (err) return;
	tnz	_err+0
	jreq	00102$
	jp	00111$
00102$:
;	tbasic.c: 1079: if (index >= IO_MAX)
	ldw	x, (0x09, sp)
	cpw	x, #0x0011
	jrslt	00104$
;	tbasic.c: 1081: err = ERR_NOIO;
	mov	_err+0, #0x17
;	tbasic.c: 1082: return;
	jp	00111$
00104$:
;	tbasic.c: 1084: if (*cip != I_EQ)
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x18
	jreq	00106$
;	tbasic.c: 1086: err = ERR_NOIO;
	mov	_err+0, #0x17
;	tbasic.c: 1087: return;
	jp	00111$
00106$:
;	tbasic.c: 1089: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1091: value = iexp();
	call	_iexp
	ldw	(0x03, sp), x
;	tbasic.c: 1092: if (err) return;
	tnz	_err+0
	jrne	00111$
;	tbasic.c: 1109: get_port(&pb, (uint8_t)index);
	ld	a, (0x0a, sp)
	push	a
	ldw	x, sp
	incw	x
	incw	x
	pushw	x
	call	_get_port
	addw	sp, #3
;	tbasic.c: 1111: if (!(testbit16(portddr, index)))
	ld	a, (0x0a, sp)
	clrw	x
	incw	x
	tnz	a
	jreq	00145$
00144$:
	sllw	x
	dec	a
	jrne	00144$
00145$:
	ldw	y, _portddr+0
	ldw	(0x05, sp), y
	ld	a, xl
	and	a, (0x06, sp)
	ld	yl, a
	ld	a, xh
	and	a, (0x05, sp)
	ld	yh, a
	ld	a, (0x0a, sp)
	jreq	00147$
00146$:
	srlw	y
	dec	a
	jrne	00146$
00147$:
	ldw	(0x07, sp), y
;	tbasic.c: 1114: io_outputinit(pb.p, pb.b);
	ldw	y, sp
	incw	y
	incw	y
	ldw	(0x09, sp), y
;	tbasic.c: 1111: if (!(testbit16(portddr, index)))
	ldw	y, (0x07, sp)
	jrne	00110$
;	tbasic.c: 1113: bitset16(portddr, index);
	ld	a, xl
	or	a, (0x06, sp)
	rlwa	x
	or	a, (0x05, sp)
	ld	xh, a
	ldw	_portddr+0, x
;	tbasic.c: 1114: io_outputinit(pb.p, pb.b);
	ldw	x, (0x09, sp)
	ld	a, (x)
	exg	a, xl
	ld	a, (0x01, sp)
	exg	a, xl
	push	a
	ld	a, xl
	push	a
	call	_io_outputinit
	popw	x
00110$:
;	tbasic.c: 1116: io_set(pb.p, pb.b, !value);
	ldw	x, (0x03, sp)
	subw	x, #0x0001
	clr	a
	rlc	a
	ld	xl, a
	ldw	y, (0x09, sp)
	ld	a, (y)
	rlwa	x
	ld	a, (0x01, sp)
	rrwa	x
	pushw	x
	addw	sp, #1
	push	a
	ld	a, xh
	push	a
	call	_io_set
	addw	sp, #3
00111$:
;	tbasic.c: 1117: }
	addw	sp, #10
	ret
;	tbasic.c: 1119: int16_t ivalue(void)
;	-----------------------------------------
;	 function ivalue
;	-----------------------------------------
_ivalue:
	sub	sp, #4
;	tbasic.c: 1124: switch (*cip)
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x0f
	jrne	00252$
	push	a
	ld	a, #0x01
	ld	(0x03, sp), a
	pop	a
	.byte 0xc5
00252$:
	clr	(0x02, sp)
00253$:
	clrw	x
	ldw	(0x03, sp), x
	tnz	(0x02, sp)
	jrne	00103$
	cp	a, #0x10
	jreq	00102$
	cp	a, #0x13
	jrne	00259$
	jp	00105$
00259$:
	cp	a, #0x1b
	jrne	00262$
	jp	00106$
00262$:
	cp	a, #0x1c
	jrne	00265$
	jp	00116$
00265$:
	cp	a, #0x1d
	jrne	00268$
	jp	00119$
00268$:
	cp	a, #0x1e
	jrne	00271$
	jp	00124$
00271$:
	cp	a, #0x20
	jrne	00274$
	jp	00111$
00274$:
	cp	a, #0x29
	jrne	00277$
	jp	00128$
00277$:
	cp	a, #0x2a
	jreq	00101$
	cp	a, #0x2b
	jreq	00104$
	jp	00133$
;	tbasic.c: 1126: case I_NUM:
00101$:
;	tbasic.c: 1128: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1129: value = *cip | *(cip + 1) << 8;
	ldw	_cip+0, x
	ld	a, (x)
	ld	yl, a
	ldw	x, _cip+0
	ld	a, (0x1, x)
	clr	(0x02, sp)
	clr	(0x03, sp)
	or	a, (0x03, sp)
	ld	xh, a
	ld	a, yl
	or	a, (0x02, sp)
	ld	xl, a
	ldw	(0x03, sp), x
;	tbasic.c: 1130: cip += 2;
	ldw	x, _cip+0
	incw	x
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1131: break;
	jp	00134$
;	tbasic.c: 1133: case I_PLUS:
00102$:
;	tbasic.c: 1135: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1136: value = ivalue();
	call	_ivalue
	ldw	(0x03, sp), x
;	tbasic.c: 1137: break;
	jp	00134$
;	tbasic.c: 1139: case I_MINUS:
00103$:
;	tbasic.c: 1141: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1142: value = 0 - ivalue();
	call	_ivalue
	negw	x
	ldw	(0x03, sp), x
;	tbasic.c: 1143: break;
	jp	00134$
;	tbasic.c: 1145: case I_VAR:
00104$:
;	tbasic.c: 1147: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1148: value = var[*cip++];
	ldw	_cip+0, x
	ld	a, (x)
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
	clrw	x
	ld	xl, a
	sllw	x
	ldw	x, (_var+0, x)
	ldw	(0x03, sp), x
;	tbasic.c: 1149: break;
	jp	00134$
;	tbasic.c: 1151: case I_OPEN:
00105$:
;	tbasic.c: 1153: value = getparam();
	call	_getparam
	ldw	(0x03, sp), x
;	tbasic.c: 1154: break;
	jp	00134$
;	tbasic.c: 1156: case I_ARRAY:
00106$:
;	tbasic.c: 1158: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1159: value = getparam();
	call	_getparam
	ldw	(0x03, sp), x
;	tbasic.c: 1160: if (err) break;
	tnz	_err+0
	jreq	00285$
	jp	00134$
00285$:
;	tbasic.c: 1161: if (value >= SIZE_ARRY)
	ldw	x, (0x03, sp)
	cpw	x, #0x0020
	jrslt	00110$
;	tbasic.c: 1163: err = ERR_SOR;
	mov	_err+0, #0x03
;	tbasic.c: 1164: break;
	jp	00134$
00110$:
;	tbasic.c: 1166: value = arr[value];
	ldw	x, (0x03, sp)
	sllw	x
	ldw	x, (_arr+0, x)
	ldw	(0x03, sp), x
;	tbasic.c: 1167: break;
	jp	00134$
;	tbasic.c: 1169: case I_IN:
00111$:
;	tbasic.c: 1171: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1172: value = getparam();
	call	_getparam
	ldw	(0x03, sp), x
;	tbasic.c: 1173: if (err) break;
	tnz	_err+0
	jreq	00287$
	jp	00134$
00287$:
;	tbasic.c: 1174: if (value >= IO_MAX)
	ldw	x, (0x03, sp)
	cpw	x, #0x0011
	jrslt	00115$
;	tbasic.c: 1176: err = ERR_NOIO;
	mov	_err+0, #0x17
;	tbasic.c: 1177: break;
	jp	00134$
00115$:
;	tbasic.c: 1179: value= iioin(value);
	ldw	x, (0x03, sp)
	pushw	x
	call	_iioin
	addw	sp, #2
	ldw	(0x03, sp), x
;	tbasic.c: 1180: break;
	jp	00134$
;	tbasic.c: 1182: case I_RND:
00116$:
;	tbasic.c: 1184: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1185: value = getparam();
	call	_getparam
	ldw	(0x03, sp), x
;	tbasic.c: 1186: if (err) break;
	tnz	_err+0
	jreq	00289$
	jp	00134$
00289$:
;	tbasic.c: 1187: value = getrnd(value);
	ldw	x, (0x03, sp)
	pushw	x
	call	_getrnd
	addw	sp, #2
	ldw	(0x03, sp), x
;	tbasic.c: 1188: break;
	jp	00134$
;	tbasic.c: 1190: case I_ABS:
00119$:
;	tbasic.c: 1192: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1193: value = getparam();
	call	_getparam
	ldw	(0x03, sp), x
;	tbasic.c: 1194: if (err) break;
	tnz	_err+0
	jreq	00290$
	jp	00134$
00290$:
;	tbasic.c: 1195: if (value < 0) value *= -1;
	ldw	x, (0x03, sp)
	jrpl	00134$
	ldw	x, (0x03, sp)
	negw	x
	ldw	(0x03, sp), x
;	tbasic.c: 1196: break;
	jra	00134$
;	tbasic.c: 1198: case I_SIZE:
00124$:
;	tbasic.c: 1200: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1201: if ((*cip != I_OPEN) || (*(cip + 1) != I_CLOSE))
	ldw	_cip+0, x
	ld	a, (x)
	cp	a, #0x13
	jrne	00125$
	ldw	x, _cip+0
	ld	a, (0x1, x)
	cp	a, #0x14
	jreq	00126$
00125$:
;	tbasic.c: 1203: err = ERR_PAREN;
	mov	_err+0, #0x11
;	tbasic.c: 1204: break;
	jra	00134$
00126$:
;	tbasic.c: 1206: cip += 2;
	ldw	x, _cip+0
	incw	x
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1207: value = getsize();
	call	_getsize
	ldw	(0x03, sp), x
;	tbasic.c: 1208: break;
	jra	00134$
;	tbasic.c: 1210: case I_ADC:
00128$:
;	tbasic.c: 1212: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1213: if ((*cip != I_OPEN) || (*(cip + 1) != I_CLOSE))
	ldw	_cip+0, x
	ld	a, (x)
	cp	a, #0x13
	jrne	00129$
	ldw	x, _cip+0
	ld	a, (0x1, x)
	cp	a, #0x14
	jreq	00130$
00129$:
;	tbasic.c: 1215: err = ERR_PAREN;
	mov	_err+0, #0x11
;	tbasic.c: 1216: break;
	jra	00134$
00130$:
;	tbasic.c: 1218: cip += 2;
	ldw	x, _cip+0
	incw	x
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1219: value= 0;
	clrw	x
	ldw	(0x03, sp), x
;	tbasic.c: 1220: for (i= 0; i< 10; i++)
	ld	a, #0x0a
00137$:
;	tbasic.c: 1222: value += adc_read();
	push	a
	call	_adc_read
	pop	a
	addw	x, (0x03, sp)
	ldw	(0x03, sp), x
	dec	a
;	tbasic.c: 1220: for (i= 0; i< 10; i++)
	tnz	a
	jrne	00137$
;	tbasic.c: 1224: value = value / 10;  
	ldw	x, (0x03, sp)
	push	#0x0a
	push	#0x00
	pushw	x
	call	__divsint
	addw	sp, #4
	ldw	(0x03, sp), x
;	tbasic.c: 1225: break;
	jra	00134$
;	tbasic.c: 1229: default:
00133$:
;	tbasic.c: 1231: err = ERR_SYNTAX;
	mov	_err+0, #0x14
;	tbasic.c: 1234: }
00134$:
;	tbasic.c: 1235: return value;
	ldw	x, (0x03, sp)
;	tbasic.c: 1236: }
	addw	sp, #4
	ret
;	tbasic.c: 1238: int16_t imul()
;	-----------------------------------------
;	 function imul
;	-----------------------------------------
_imul:
	pushw	x
;	tbasic.c: 1243: value = ivalue();
	call	_ivalue
	ldw	(0x01, sp), x
;	tbasic.c: 1244: if (err) return -1;
	tnz	_err+0
	jreq	00110$
	clrw	x
	decw	x
	jra	00112$
;	tbasic.c: 1246: while (1)
00110$:
;	tbasic.c: 1248: switch (*cip)
	ldw	x, _cip+0
	ld	a, (x)
;	tbasic.c: 1252: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1248: switch (*cip)
	cp	a, #0x11
	jreq	00103$
	cp	a, #0x12
	jreq	00104$
	jra	00107$
;	tbasic.c: 1250: case I_MUL:
00103$:
;	tbasic.c: 1252: cip++;
	ldw	_cip+0, x
;	tbasic.c: 1253: tmp = ivalue();
	call	_ivalue
;	tbasic.c: 1254: value *= tmp;
	pushw	x
	ldw	x, (0x03, sp)
	pushw	x
	call	__mulint
	addw	sp, #4
	ldw	(0x01, sp), x
;	tbasic.c: 1255: break;
	jra	00110$
;	tbasic.c: 1257: case I_DIV:
00104$:
;	tbasic.c: 1259: cip++;
	ldw	_cip+0, x
;	tbasic.c: 1260: tmp = ivalue();
	call	_ivalue
;	tbasic.c: 1261: if (tmp == 0)
	tnzw	x
	jrne	00106$
;	tbasic.c: 1263: err = ERR_DIVBY0;
	mov	_err+0, #0x01
;	tbasic.c: 1264: return -1;
	clrw	x
	decw	x
	jra	00112$
00106$:
;	tbasic.c: 1266: value /= tmp;
	pushw	x
	ldw	x, (0x03, sp)
	pushw	x
	call	__divsint
	addw	sp, #4
	ldw	(0x01, sp), x
;	tbasic.c: 1267: break;
	jra	00110$
;	tbasic.c: 1269: default: return value;
00107$:
	ldw	x, (0x01, sp)
;	tbasic.c: 1270: }
00112$:
;	tbasic.c: 1272: }
	addw	sp, #2
	ret
;	tbasic.c: 1274: int16_t iplus()
;	-----------------------------------------
;	 function iplus
;	-----------------------------------------
_iplus:
	sub	sp, #5
;	tbasic.c: 1279: value = imul();
	call	_imul
	ldw	(0x01, sp), x
;	tbasic.c: 1280: if (err) return -1;
	tnz	_err+0
	jreq	00108$
	clrw	x
	decw	x
	jra	00110$
;	tbasic.c: 1282: while (1)
00108$:
;	tbasic.c: 1284: switch (*cip)
	ldw	x, _cip+0
	ld	a, (x)
	ld	(0x03, sp), a
;	tbasic.c: 1288: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	(0x04, sp), x
;	tbasic.c: 1284: switch (*cip)
	ld	a, (0x03, sp)
	cp	a, #0x0f
	jreq	00104$
	ld	a, (0x03, sp)
	cp	a, #0x10
	jrne	00105$
;	tbasic.c: 1288: cip++;
	ldw	x, (0x04, sp)
	ldw	_cip+0, x
;	tbasic.c: 1289: tmp = imul();
	call	_imul
;	tbasic.c: 1290: value += tmp;
	addw	x, (0x01, sp)
	ldw	(0x01, sp), x
;	tbasic.c: 1291: break;
	jra	00108$
;	tbasic.c: 1293: case I_MINUS:
00104$:
;	tbasic.c: 1295: cip++;
	ldw	x, (0x04, sp)
	ldw	_cip+0, x
;	tbasic.c: 1296: tmp = imul();
	call	_imul
;	tbasic.c: 1297: value -= tmp;
	negw	x
	addw	x, (0x01, sp)
	ldw	(0x01, sp), x
;	tbasic.c: 1298: break;
	jra	00108$
;	tbasic.c: 1300: default: return value;
00105$:
	ldw	x, (0x01, sp)
;	tbasic.c: 1301: }
00110$:
;	tbasic.c: 1303: }
	addw	sp, #5
	ret
;	tbasic.c: 1310: int16_t iexp(void)
;	-----------------------------------------
;	 function iexp
;	-----------------------------------------
_iexp:
	sub	sp, #4
;	tbasic.c: 1314: value = iplus();
	call	_iplus
	ldw	(0x01, sp), x
;	tbasic.c: 1315: if (err) return -1;
	tnz	_err+0
	jreq	00112$
	clrw	x
	decw	x
	jp	00114$
;	tbasic.c: 1317: while (1)
00112$:
;	tbasic.c: 1319: switch (*cip)
	ldw	x, _cip+0
	ld	a, (x)
;	tbasic.c: 1323: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	(0x03, sp), x
;	tbasic.c: 1319: switch (*cip)
	cp	a, #0x15
	jrne	00158$
	jp	00108$
00158$:
	cp	a, #0x16
	jreq	00104$
	cp	a, #0x17
	jreq	00107$
	cp	a, #0x18
	jreq	00103$
	cp	a, #0x19
	jreq	00106$
	cp	a, #0x1a
	jreq	00105$
	jp	00109$
;	tbasic.c: 1321: case I_EQ:
00103$:
;	tbasic.c: 1323: cip++;
	ldw	x, (0x03, sp)
	ldw	_cip+0, x
;	tbasic.c: 1324: tmp = iplus();
	call	_iplus
;	tbasic.c: 1325: value = (value == tmp);
	cpw	x, (0x01, sp)
	jrne	00176$
	ld	a, #0x01
	.byte 0x21
00176$:
	clr	a
00177$:
	clrw	x
	ld	xl, a
	ldw	(0x01, sp), x
;	tbasic.c: 1326: break;
	jra	00112$
;	tbasic.c: 1328: case I_SHARP:
00104$:
;	tbasic.c: 1330: cip++;
	ldw	x, (0x03, sp)
	ldw	_cip+0, x
;	tbasic.c: 1331: tmp = iplus();
	call	_iplus
;	tbasic.c: 1332: value = (value != tmp);
	cpw	x, (0x01, sp)
	jrne	00179$
	ld	a, #0x01
	.byte 0x21
00179$:
	clr	a
00180$:
	xor	a, #0x01
	clrw	x
	ld	xl, a
	ldw	(0x01, sp), x
;	tbasic.c: 1333: break;
	jra	00112$
;	tbasic.c: 1335: case I_LT:
00105$:
;	tbasic.c: 1337: cip++;
	ldw	x, (0x03, sp)
	ldw	_cip+0, x
;	tbasic.c: 1338: tmp = iplus();
	call	_iplus
	ldw	(0x03, sp), x
;	tbasic.c: 1339: value = (value < tmp);
	ldw	x, (0x01, sp)
	cpw	x, (0x03, sp)
	jrslt	00181$
	clr	a
	.byte 0xc5
00181$:
	ld	a, #0x01
00182$:
	clrw	x
	ld	xl, a
	ldw	(0x01, sp), x
;	tbasic.c: 1340: break;
	jra	00112$
;	tbasic.c: 1342: case I_LTE:
00106$:
;	tbasic.c: 1344: cip++;
	ldw	x, (0x03, sp)
	ldw	_cip+0, x
;	tbasic.c: 1345: tmp = iplus();
	call	_iplus
;	tbasic.c: 1346: value = (value <= tmp);
	cpw	x, (0x01, sp)
	jrslt	00183$
	clr	a
	.byte 0xc5
00183$:
	ld	a, #0x01
00184$:
	xor	a, #0x01
	clrw	x
	ld	xl, a
	ldw	(0x01, sp), x
;	tbasic.c: 1347: break;
	jp	00112$
;	tbasic.c: 1349: case I_GT:
00107$:
;	tbasic.c: 1351: cip++;
	ldw	x, (0x03, sp)
	ldw	_cip+0, x
;	tbasic.c: 1352: tmp = iplus();
	call	_iplus
;	tbasic.c: 1353: value = (value > tmp);
	cpw	x, (0x01, sp)
	jrslt	00185$
	clr	a
	.byte 0xc5
00185$:
	ld	a, #0x01
00186$:
	clrw	x
	ld	xl, a
	ldw	(0x01, sp), x
;	tbasic.c: 1354: break;
	jp	00112$
;	tbasic.c: 1356: case I_GTE:
00108$:
;	tbasic.c: 1358: cip++;
	ldw	x, (0x03, sp)
	ldw	_cip+0, x
;	tbasic.c: 1359: tmp = iplus();
	call	_iplus
	ldw	(0x03, sp), x
;	tbasic.c: 1360: value = (value >= tmp);
	ldw	x, (0x01, sp)
	cpw	x, (0x03, sp)
	jrslt	00187$
	clr	a
	.byte 0xc5
00187$:
	ld	a, #0x01
00188$:
	xor	a, #0x01
	clrw	x
	ld	xl, a
	ldw	(0x01, sp), x
;	tbasic.c: 1361: break;
	jp	00112$
;	tbasic.c: 1363: default: return value;
00109$:
	ldw	x, (0x01, sp)
;	tbasic.c: 1364: }
00114$:
;	tbasic.c: 1366: }
	addw	sp, #4
	ret
;	tbasic.c: 1368: void iprint(void)
;	-----------------------------------------
;	 function iprint
;	-----------------------------------------
_iprint:
	sub	sp, #3
;	tbasic.c: 1374: len = 0;
	clrw	x
	ldw	(0x01, sp), x
;	tbasic.c: 1375: while (*cip != I_SEMI && *cip != I_EOL)
00122$:
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x0e
	jrne	00194$
	jp	00124$
00194$:
	cp	a, #0x2d
	jrne	00197$
	jp	00124$
00197$:
;	tbasic.c: 1381: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1377: switch (*cip)
	cp	a, #0x16
	jreq	00105$
	cp	a, #0x2c
	jrne	00108$
;	tbasic.c: 1381: cip++;
;	tbasic.c: 1382: i = *cip++;
	ldw	_cip+0, x
	ld	a, (x)
	ld	(0x03, sp), a
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1383: while (i--) uart_putchar(*cip++);
00102$:
	ld	a, (0x03, sp)
	dec	(0x03, sp)
	tnz	a
	jreq	00111$
	ldw	x, _cip+0
	ld	a, (x)
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
	push	a
	call	_uart_putchar
	pop	a
	jra	00102$
;	tbasic.c: 1386: case I_SHARP:
00105$:
;	tbasic.c: 1388: cip++;
	ldw	_cip+0, x
;	tbasic.c: 1389: len = iexp();
	call	_iexp
	ldw	(0x01, sp), x
;	tbasic.c: 1390: if (err) return;
	tnz	_err+0
	jreq	00111$
	jra	00125$
;	tbasic.c: 1393: default:
00108$:
;	tbasic.c: 1395: value = iexp();
	call	_iexp
;	tbasic.c: 1396: if (err) return;
	tnz	_err+0
	jrne	00125$
;	tbasic.c: 1397: putnum(value, len);
	ldw	y, (0x01, sp)
	pushw	y
	pushw	x
	call	_putnum
	addw	sp, #4
;	tbasic.c: 1400: }
00111$:
;	tbasic.c: 1375: while (*cip != I_SEMI && *cip != I_EOL)
	ldw	x, _cip+0
	ld	a, (x)
;	tbasic.c: 1402: if (*cip == I_COMMA)
	cp	a, #0x0d
	jrne	00119$
;	tbasic.c: 1404: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1375: while (*cip != I_SEMI && *cip != I_EOL)
	ldw	_cip+0, x
	ld	a, (x)
;	tbasic.c: 1405: if (*cip == I_SEMI || *cip == I_EOL) return;
	cp	a, #0x0e
	jreq	00125$
	cp	a, #0x2d
	jreq	00125$
	jp	00122$
00119$:
;	tbasic.c: 1409: if (*cip != I_SEMI && *cip != I_EOL)
	cp	a, #0x0e
	jrne	00218$
	jp	00122$
00218$:
	cp	a, #0x2d
	jrne	00221$
	jp	00122$
00221$:
;	tbasic.c: 1411: err = ERR_SYNTAX;
	mov	_err+0, #0x14
;	tbasic.c: 1412: return;
	jra	00125$
00124$:
;	tbasic.c: 1416: newline();
	addw	sp, #3
	jp	_newline
00125$:
;	tbasic.c: 1417: }
	addw	sp, #3
	ret
;	tbasic.c: 1419: void iinput(void)
;	-----------------------------------------
;	 function iinput
;	-----------------------------------------
_iinput:
	sub	sp, #4
;	tbasic.c: 1426: while (1)
00128$:
;	tbasic.c: 1428: prompt = 1;
	ld	a, #0x01
	ld	(0x04, sp), a
;	tbasic.c: 1430: if (*cip == I_STR)
	ldw	x, _cip+0
	ld	a, (x)
;	tbasic.c: 1432: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	(0x01, sp), x
;	tbasic.c: 1430: if (*cip == I_STR)
	cp	a, #0x2c
	jrne	00105$
;	tbasic.c: 1432: cip++;
	ldw	x, (0x01, sp)
;	tbasic.c: 1433: i = *cip++;
	ldw	_cip+0, x
	ld	a, (x)
	ld	(0x04, sp), a
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1434: while (i--) uart_putchar(*cip++);
00101$:
	ld	a, (0x04, sp)
	ld	(0x03, sp), a
	dec	(0x04, sp)
;	tbasic.c: 1432: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	(0x01, sp), x
;	tbasic.c: 1430: if (*cip == I_STR)
	ldw	x, _cip+0
	ld	a, (x)
;	tbasic.c: 1434: while (i--) uart_putchar(*cip++);
	tnz	(0x03, sp)
	jreq	00103$
	ldw	x, (0x01, sp)
	ldw	_cip+0, x
	push	a
	call	_uart_putchar
	pop	a
	jra	00101$
00103$:
;	tbasic.c: 1435: prompt = 0;
	clr	(0x04, sp)
00105$:
;	tbasic.c: 1438: switch (*cip)
	cp	a, #0x1b
	jreq	00111$
	cp	a, #0x2b
	jreq	00232$
	jp	00120$
00232$:
;	tbasic.c: 1442: cip++;
	ldw	x, (0x01, sp)
	ldw	_cip+0, x
;	tbasic.c: 1443: if (prompt)
	tnz	(0x04, sp)
	jreq	00108$
;	tbasic.c: 1447: uart_putstring(": ");
	push	#<(___str_3+0)
	push	#((___str_3+0) >> 8)
	call	_uart_putstring
	popw	x
00108$:
;	tbasic.c: 1449: value = getnum();
	call	_getnum
	exgw	x, y
;	tbasic.c: 1450: if (err) return;
	tnz	_err+0
	jreq	00110$
	jp	00130$
00110$:
;	tbasic.c: 1451: var[*cip++] = value;
	ldw	x, _cip+0
	ld	a, (x)
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
	clrw	x
	ld	xl, a
	sllw	x
	ldw	((_var+0), x), y
;	tbasic.c: 1452: break;
	jra	00121$
;	tbasic.c: 1454: case I_ARRAY:
00111$:
;	tbasic.c: 1456: cip++;
	ldw	x, (0x01, sp)
	ldw	_cip+0, x
;	tbasic.c: 1457: index = getparam();
	call	_getparam
	ldw	(0x02, sp), x
;	tbasic.c: 1458: if (err) return;
	tnz	_err+0
	jrne	00130$
;	tbasic.c: 1459: if (index >= SIZE_ARRY)
	ldw	x, (0x02, sp)
	cpw	x, #0x0020
	jrslt	00115$
;	tbasic.c: 1461: err = ERR_SOR;
	mov	_err+0, #0x03
;	tbasic.c: 1462: return;
	jra	00130$
00115$:
;	tbasic.c: 1464: if (prompt)
	tnz	(0x04, sp)
	jreq	00117$
;	tbasic.c: 1466: uart_putstring("@(");
	push	#<(___str_4+0)
	push	#((___str_4+0) >> 8)
	call	_uart_putstring
	popw	x
;	tbasic.c: 1467: putnum(index, 0);
	clrw	x
	pushw	x
	ldw	x, (0x04, sp)
	pushw	x
	call	_putnum
	addw	sp, #4
;	tbasic.c: 1468: uart_putstring("):");
	push	#<(___str_5+0)
	push	#((___str_5+0) >> 8)
	call	_uart_putstring
	popw	x
00117$:
;	tbasic.c: 1470: value = getnum();
	call	_getnum
	exgw	x, y
;	tbasic.c: 1471: if (err) return;
	tnz	_err+0
	jrne	00130$
;	tbasic.c: 1472: arr[index] = value;
	ldw	x, (0x02, sp)
	sllw	x
	ldw	((_arr+0), x), y
;	tbasic.c: 1473: break;
	jra	00121$
;	tbasic.c: 1475: default:
00120$:
;	tbasic.c: 1477: err = ERR_SYNTAX;
	mov	_err+0, #0x14
;	tbasic.c: 1478: return;
	jra	00130$
;	tbasic.c: 1480: }
00121$:
;	tbasic.c: 1482: switch (*cip)
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x0d
	jreq	00122$
	cp	a, #0x0e
	jreq	00130$
	cp	a, #0x2d
	jreq	00130$
	jra	00125$
;	tbasic.c: 1484: case I_COMMA:
00122$:
;	tbasic.c: 1486: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1487: break;
;	tbasic.c: 1490: case I_EOL:  return;
	jp	00128$
;	tbasic.c: 1491: default:
00125$:
;	tbasic.c: 1493: err = ERR_SYNTAX;
	mov	_err+0, #0x14
;	tbasic.c: 1494: return;
;	tbasic.c: 1496: }
00130$:
;	tbasic.c: 1498: }
	addw	sp, #4
	ret
;	tbasic.c: 1501: void ivar(void)
;	-----------------------------------------
;	 function ivar
;	-----------------------------------------
_ivar:
	sub	sp, #4
;	tbasic.c: 1506: index = *cip++;
	ldw	x, _cip+0
	ld	a, (x)
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
	clrw	x
	ld	xl, a
	ldw	(0x01, sp), x
;	tbasic.c: 1507: if (*cip != I_EQ)
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x18
	jreq	00102$
;	tbasic.c: 1509: err = ERR_VWOEQ;
	mov	_err+0, #0x12
;	tbasic.c: 1510: return;
	jra	00105$
00102$:
;	tbasic.c: 1512: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1514: value = iexp();
	call	_iexp
	ldw	(0x03, sp), x
;	tbasic.c: 1515: if (err) return;
	tnz	_err+0
	jrne	00105$
;	tbasic.c: 1517: var[index] = value;
	ldw	x, (0x01, sp)
	sllw	x
	ldw	y, (0x03, sp)
	ldw	((_var+0), x), y
00105$:
;	tbasic.c: 1518: }
	addw	sp, #4
	ret
;	tbasic.c: 1520: void iarray()
;	-----------------------------------------
;	 function iarray
;	-----------------------------------------
_iarray:
	pushw	x
;	tbasic.c: 1525: index = getparam();
	call	_getparam
	ldw	(0x01, sp), x
;	tbasic.c: 1526: if (err) return;
	tnz	_err+0
	jrne	00109$
;	tbasic.c: 1528: if (index >= SIZE_ARRY)
	ldw	x, (0x01, sp)
	cpw	x, #0x0020
	jrslt	00104$
;	tbasic.c: 1530: err = ERR_SOR;
	mov	_err+0, #0x03
;	tbasic.c: 1531: return;
	jra	00109$
00104$:
;	tbasic.c: 1534: if (*cip != I_EQ)
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x18
	jreq	00106$
;	tbasic.c: 1536: err = ERR_VWOEQ;
	mov	_err+0, #0x12
;	tbasic.c: 1537: return;
	jra	00109$
00106$:
;	tbasic.c: 1539: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1541: value = iexp();
	call	_iexp
	exgw	x, y
;	tbasic.c: 1542: if (err) return;
	tnz	_err+0
	jrne	00109$
;	tbasic.c: 1544: arr[index] = value;
	ldw	x, (0x01, sp)
	sllw	x
	ldw	((_arr+0), x), y
00109$:
;	tbasic.c: 1545: }
	popw	x
	ret
;	tbasic.c: 1547: void ilet(void)
;	-----------------------------------------
;	 function ilet
;	-----------------------------------------
_ilet:
;	tbasic.c: 1549: switch (*cip)
	ldw	x, _cip+0
	ld	a, (x)
;	tbasic.c: 1553: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1549: switch (*cip)
	cp	a, #0x1b
	jreq	00102$
	cp	a, #0x2b
	jrne	00103$
;	tbasic.c: 1553: cip++;
	ldw	_cip+0, x
;	tbasic.c: 1554: ivar();                 // Variable assignment
;	tbasic.c: 1555: break;
	jp	_ivar
;	tbasic.c: 1557: case I_ARRAY:
00102$:
;	tbasic.c: 1559: cip++;
	ldw	_cip+0, x
;	tbasic.c: 1560: iarray();               // Array assignment
;	tbasic.c: 1561: break;
	jp	_iarray
;	tbasic.c: 1563: default:
00103$:
;	tbasic.c: 1565: err = ERR_LETWOV;
	mov	_err+0, #0x0e
;	tbasic.c: 1568: }
;	tbasic.c: 1569: }
	ret
;	tbasic.c: 1571: uint8_t *iexe(void)
;	-----------------------------------------
;	 function iexe
;	-----------------------------------------
_iexe:
	sub	sp, #6
;	tbasic.c: 1582: while (*cip != I_EOL)
00196$:
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x2d
	jrne	00487$
	jp	00198$
00487$:
;	tbasic.c: 1584: if (uart_ischar())
	call	_uart_ischar
	tnz	a
	jreq	00104$
;	tbasic.c: 1586: if (uart_readkey() == 27)               // ESC
	call	_uart_readkey
	cp	a, #0x1b
	jrne	00104$
;	tbasic.c: 1588: err = ERR_ESC;
	mov	_err+0, #0x16
;	tbasic.c: 1589: return NULL;
	clrw	x
	jp	00199$
00104$:
;	tbasic.c: 1593: switch (*cip)
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x00
	jrne	00494$
	jp	00116$
00494$:
	cp	a, #0x01
	jrne	00497$
	jp	00129$
00497$:
	cp	a, #0x02
	jrne	00500$
	jp	00136$
00500$:
	cp	a, #0x03
	jrne	00503$
	jp	00139$
00503$:
	cp	a, #0x06
	jrne	00506$
	jp	00157$
00506$:
	cp	a, #0x07
	jrne	00509$
	jp	00169$
00509$:
	cp	a, #0x08
	jrne	00512$
	jp	00175$
00512$:
	cp	a, #0x09
	jrne	00515$
	jp	00179$
00515$:
	cp	a, #0x0a
	jrne	00518$
	jp	00187$
00518$:
	cp	a, #0x0b
	jrne	00521$
	jp	00186$
00521$:
	cp	a, #0x0c
	jrne	00524$
	jp	00185$
00524$:
	cp	a, #0x0e
	jrne	00527$
	jp	00191$
00527$:
	cp	a, #0x1b
	jrne	00530$
	jp	00183$
00530$:
	cp	a, #0x1f
	jrne	00533$
	jp	00184$
00533$:
	cp	a, #0x21
	jreq	00105$
	cp	a, #0x22
	jrne	00539$
	jp	00190$
00539$:
	cp	a, #0x23
	jrne	00542$
	jp	00190$
00542$:
	cp	a, #0x24
	jrne	00545$
	jp	00190$
00545$:
	cp	a, #0x27
	jrne	00548$
	jp	00124$
00548$:
	cp	a, #0x28
	jrne	00551$
	jp	00121$
00551$:
	cp	a, #0x2b
	jrne	00554$
	jp	00182$
00554$:
	jp	00192$
;	tbasic.c: 1595: case I_FUNC:
00105$:
;	tbasic.c: 1597: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1598: if (*cip != I_NUM)
	ldw	_cip+0, x
	ld	a, (x)
	cp	a, #0x2a
	jreq	00107$
;	tbasic.c: 1600: err= ERR_NOVAL;
	mov	_err+0, #0x18
;	tbasic.c: 1601: break;
	jp	00193$
00107$:
;	tbasic.c: 1604: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1605: arg1 = *cip;
	ldw	_cip+0, x
	ld	a, (x)
	clrw	x
	ld	xl, a
	exgw	x, y
;	tbasic.c: 1606: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1607: arg1 += (*cip << 8);
	ldw	_cip+0, x
	ld	a, (x)
	ld	xh, a
	clr	a
	ldw	(0x05, sp), y
	ld	xl, a
	addw	x, (0x05, sp)
	ldw	(0x03, sp), x
;	tbasic.c: 1609: cip++;                      // Komma abfragen
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1610: if (*cip != I_COMMA)
	ldw	_cip+0, x
	ld	a, (x)
	cp	a, #0x0d
	jreq	00109$
;	tbasic.c: 1612: err= ERR_NOVAL;
	mov	_err+0, #0x18
;	tbasic.c: 1613: break;
	jp	00193$
00109$:
;	tbasic.c: 1616: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1618: if ((*cip != I_NUM) && (*cip != I_VAR))
	ldw	_cip+0, x
	ld	a, (x)
	cp	a, #0x2a
	jreq	00111$
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x2b
	jreq	00111$
;	tbasic.c: 1620: err= ERR_NOVAL;
	mov	_err+0, #0x18
;	tbasic.c: 1621: break;
	jp	00193$
00111$:
;	tbasic.c: 1624: if (*cip == I_NUM)
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x2a
	jrne	00114$
;	tbasic.c: 1626: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1627: arg2= *cip;
	ldw	_cip+0, x
	ld	a, (x)
	clrw	x
	ld	xl, a
	exgw	x, y
;	tbasic.c: 1628: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1629: arg2 += (*cip << 8);
	ldw	_cip+0, x
	ld	a, (x)
	ld	xh, a
	clr	a
	ld	xl, a
	ldw	(0x05, sp), x
	addw	y, (0x05, sp)
	jra	00115$
00114$:
;	tbasic.c: 1633: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1634: arg2= var[*cip];
	ldw	_cip+0, x
	ld	a, (x)
	clrw	x
	ld	xl, a
	sllw	x
	ldw	x, (_var+0, x)
	exgw	x, y
00115$:
;	tbasic.c: 1636: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1637: sysfunc(arg1, arg2);
	pushw	y
	ldw	x, (0x05, sp)
	pushw	x
	call	_sysfunc
	addw	sp, #4
;	tbasic.c: 1638: break;
	jp	00193$
;	tbasic.c: 1640: case I_GOTO:
00116$:
;	tbasic.c: 1642: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1643: lineno = iexp();
	call	_iexp
	ldw	(0x03, sp), x
;	tbasic.c: 1644: if (err) break;
	tnz	_err+0
	jreq	00571$
	jp	00193$
00571$:
;	tbasic.c: 1645: lp = getlp(lineno);                   // Zeilennummer suchen
	ldw	x, (0x03, sp)
	pushw	x
	call	_getlp
	addw	sp, #2
;	tbasic.c: 1646: if (lineno != getlineno(lp))          // wenn nicht gefunden
	ldw	(0x05, sp), x
	pushw	x
	call	_getlineno
	addw	sp, #2
	cpw	x, (0x03, sp)
	jreq	00120$
;	tbasic.c: 1648: err = ERR_ULN;
	mov	_err+0, #0x10
;	tbasic.c: 1649: break;
	jp	00193$
00120$:
;	tbasic.c: 1652: clp = lp;
	ldw	x, (0x05, sp)
;	tbasic.c: 1653: cip = clp + 3;
	ldw	_clp+0, x
	addw	x, #0x0003
	ldw	_cip+0, x
;	tbasic.c: 1654: break;
	jp	00193$
;	tbasic.c: 1656: case I_DELAY:
00121$:
;	tbasic.c: 1658: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1659: value = iexp();
	call	_iexp
;	tbasic.c: 1660: if (err) break;
	tnz	_err+0
	jreq	00575$
	jp	00193$
00575$:
;	tbasic.c: 1661: delay(value);
	pushw	x
	call	_delay
	popw	x
;	tbasic.c: 1662: break;        
	jp	00193$
;	tbasic.c: 1664: case I_BYTEOUT:
00124$:
;	tbasic.c: 1666: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1667: value = iexp();
	call	_iexp
;	tbasic.c: 1668: if (err) break;
	tnz	_err+0
	jreq	00576$
	jp	00193$
00576$:
;	tbasic.c: 1669: if (value > 255)
	ldw	y, x
	cpw	y, #0x00ff
	jrsle	00128$
;	tbasic.c: 1671: err= ERR_VALOVF;
	mov	_err+0, #0x19
;	tbasic.c: 1672: break;
	jp	00193$
00128$:
;	tbasic.c: 1674: ibyteout(value);
	ld	a, xl
	push	a
	call	_ibyteout
	pop	a
;	tbasic.c: 1675: break;
	jp	00193$
;	tbasic.c: 1677: case I_GOSUB:
00129$:
;	tbasic.c: 1679: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1680: lineno = iexp();
	call	_iexp
	ldw	(0x03, sp), x
;	tbasic.c: 1681: if (err) break;
	tnz	_err+0
	jreq	00578$
	jp	00193$
00578$:
;	tbasic.c: 1682: lp = getlp(lineno);
	ldw	x, (0x03, sp)
	pushw	x
	call	_getlp
	addw	sp, #2
;	tbasic.c: 1683: if (lineno != getlineno(lp))
	ldw	(0x05, sp), x
	pushw	x
	call	_getlineno
	addw	sp, #2
	cpw	x, (0x03, sp)
	jreq	00133$
;	tbasic.c: 1685: err = ERR_ULN;
	mov	_err+0, #0x10
;	tbasic.c: 1686: break;
	jp	00193$
00133$:
;	tbasic.c: 1690: if (gstki > SIZE_GSTK - 2)             // stack overflow ?
	ld	a, _gstki+0
	cp	a, #0x04
	jrule	00135$
;	tbasic.c: 1692: err = ERR_GSTKOF;
	mov	_err+0, #0x06
;	tbasic.c: 1693: break;
	jp	00193$
00135$:
;	tbasic.c: 1695: gstk[gstki++] = clp;
	ld	a, _gstki+0
	inc	_gstki+0
	clrw	x
	ld	xl, a
	sllw	x
	ldw	y, _clp+0
	ldw	((_gstk+0), x), y
;	tbasic.c: 1696: gstk[gstki++] = cip;
	ld	a, _gstki+0
	inc	_gstki+0
	clrw	x
	ld	xl, a
	sllw	x
	ldw	y, _cip+0
	ldw	((_gstk+0), x), y
;	tbasic.c: 1698: clp = lp;
	ldw	x, (0x05, sp)
;	tbasic.c: 1699: cip = clp + 3;
	ldw	_clp+0, x
	addw	x, #0x0003
	ldw	_cip+0, x
;	tbasic.c: 1700: break;
	jp	00193$
;	tbasic.c: 1702: case I_RETURN:
00136$:
;	tbasic.c: 1704: if (gstki < 2)                         // stack underflow ?
	ld	a, _gstki+0
	cp	a, #0x02
	jrnc	00138$
;	tbasic.c: 1706: err = ERR_GSTKUF;
	mov	_err+0, #0x07
;	tbasic.c: 1707: break;
	jp	00193$
00138$:
;	tbasic.c: 1709: cip = gstk[--gstki];
	dec	_gstki+0
	ld	a, _gstki+0
	clrw	x
	ld	xl, a
	sllw	x
	ldw	x, (_gstk+0, x)
	ldw	_cip+0, x
;	tbasic.c: 1710: clp = gstk[--gstki];
	dec	_gstki+0
	ld	a, _gstki+0
	clrw	x
	ld	xl, a
	sllw	x
	ldw	x, (_gstk+0, x)
	ldw	_clp+0, x
;	tbasic.c: 1711: break;
	jp	00193$
;	tbasic.c: 1713: case I_FOR:
00139$:
;	tbasic.c: 1715: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1717: if (*cip++ != I_VAR)
	ldw	_cip+0, x
	ld	a, (x)
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
	cp	a, #0x2b
	jreq	00141$
;	tbasic.c: 1719: err = ERR_FORWOV;
	mov	_err+0, #0x0c
;	tbasic.c: 1720: break;
	jp	00193$
00141$:
;	tbasic.c: 1723: index = *cip;
	ldw	x, _cip+0
	ld	a, (x)
	clrw	x
	ld	xl, a
	ldw	(0x01, sp), x
;	tbasic.c: 1724: ivar();
	call	_ivar
;	tbasic.c: 1725: if (err) break;
	tnz	_err+0
	jreq	00587$
	jp	00193$
00587$:
;	tbasic.c: 1727: if (*cip == I_TO)
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x04
	jrne	00145$
;	tbasic.c: 1729: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1730: vto = iexp();
	call	_iexp
	ldw	(0x03, sp), x
	jra	00146$
00145$:
;	tbasic.c: 1734: err = ERR_FORWOTO;
	mov	_err+0, #0x0d
;	tbasic.c: 1735: break;
	jp	00193$
00146$:
;	tbasic.c: 1738: if (*cip == I_STEP)
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x05
	jrne	00148$
;	tbasic.c: 1740: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1741: vstep = iexp();
	call	_iexp
	ldw	(0x05, sp), x
	jra	00149$
00148$:
;	tbasic.c: 1745: vstep = 1;
	ldw	x, #0x0001
	ldw	(0x05, sp), x
00149$:
;	tbasic.c: 1750: if (((vstep < 0) && (-32767 - vstep > vto)) ||
	ldw	y, (0x05, sp)
	jrpl	00154$
	ldw	x, #0x8001
	subw	x, (0x05, sp)
	cpw	x, (0x03, sp)
	jrsgt	00150$
00154$:
;	tbasic.c: 1751: ((vstep > 0) && (32767 - vstep < vto)))
	cpw	y, #0x0000
	jrsle	00151$
	ldw	x, #0x7fff
	subw	x, (0x05, sp)
	cpw	x, (0x03, sp)
	jrsge	00151$
00150$:
;	tbasic.c: 1753: err = ERR_VOF;
	mov	_err+0, #0x02
;	tbasic.c: 1754: break;
	jp	00193$
00151$:
;	tbasic.c: 1758: if (lstki > SIZE_LSTK - 5)                   // stack overflow ?
	ld	a, _lstki+0
	cp	a, #0x0a
	jrule	00156$
;	tbasic.c: 1760: err = ERR_LSTKOF;
	mov	_err+0, #0x08
;	tbasic.c: 1761: break;
	jp	00193$
00156$:
;	tbasic.c: 1763: lstk[lstki++] = clp;
	ld	a, _lstki+0
	inc	_lstki+0
	clrw	x
	ld	xl, a
	sllw	x
	ldw	y, _clp+0
	ldw	((_lstk+0), x), y
;	tbasic.c: 1764: lstk[lstki++] = cip;
	ld	a, _lstki+0
	inc	_lstki+0
	clrw	x
	ld	xl, a
	sllw	x
	ldw	y, _cip+0
	ldw	((_lstk+0), x), y
;	tbasic.c: 1766: lstk[lstki++] = (uint8_t*)(uintptr_t)vto;
	ld	a, _lstki+0
	inc	_lstki+0
	clrw	x
	ld	xl, a
	sllw	x
	ldw	y, (0x03, sp)
	ldw	((_lstk+0), x), y
;	tbasic.c: 1767: lstk[lstki++] = (uint8_t*)(uintptr_t)vstep;
	ld	a, _lstki+0
	inc	_lstki+0
	clrw	x
	ld	xl, a
	sllw	x
	ldw	y, (0x05, sp)
	ldw	((_lstk+0), x), y
;	tbasic.c: 1768: lstk[lstki++] = (uint8_t*)(uintptr_t)index;
	ld	a, _lstki+0
	inc	_lstki+0
	clrw	x
	ld	xl, a
	sllw	x
	ldw	y, (0x01, sp)
	ldw	((_lstk+0), x), y
;	tbasic.c: 1769: break;
	jp	00193$
;	tbasic.c: 1771: case I_NEXT:
00157$:
;	tbasic.c: 1773: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1775: if (lstki < 5)                              // leerer Stack
	ld	a, _lstki+0
	cp	a, #0x05
	jrnc	00159$
;	tbasic.c: 1777: err = ERR_LSTKUF;
	mov	_err+0, #0x09
;	tbasic.c: 1778: break;
	jp	00193$
00159$:
;	tbasic.c: 1781: index = (int16_t)(uintptr_t)lstk[lstki - 1];
	ld	a, _lstki+0
	ld	(0x06, sp), a
	dec	a
	ld	xl, a
	rlc	a
	clr	a
	sbc	a, #0x00
	ld	xh, a
	sllw	x
	ldw	x, (_lstk+0, x)
	ldw	(0x01, sp), x
;	tbasic.c: 1782: if (*cip++ != I_VAR)
	ldw	x, _cip+0
	ld	a, (x)
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
	cp	a, #0x2b
	jreq	00161$
;	tbasic.c: 1784: err = ERR_NEXTWOV;
	mov	_err+0, #0x0a
;	tbasic.c: 1785: break;
	jp	00193$
00161$:
;	tbasic.c: 1787: if (*cip++ != index)
	ldw	x, _cip+0
	ld	a, (x)
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
	clrw	x
	ld	xl, a
	cpw	x, (0x01, sp)
	jreq	00163$
;	tbasic.c: 1789: err = ERR_NEXTUM;
	mov	_err+0, #0x0b
;	tbasic.c: 1790: break;
	jp	00193$
00163$:
;	tbasic.c: 1793: vstep = (int16_t)(uintptr_t)lstk[lstki - 2];
	ld	a, (0x06, sp)
	sub	a, #0x02
	ld	xl, a
	rlc	a
	clr	a
	sbc	a, #0x00
	ld	xh, a
	sllw	x
	ldw	x, (_lstk+0, x)
	ldw	(0x03, sp), x
;	tbasic.c: 1794: var[index] += vstep;
	ldw	x, (0x01, sp)
	sllw	x
	addw	x, #(_var+0)
	ldw	y, x
	ldw	y, (y)
	addw	y, (0x03, sp)
	ldw	(x), y
;	tbasic.c: 1795: vto = (int16_t)(uintptr_t)lstk[lstki - 3];
	ld	a, _lstki+0
	sub	a, #0x03
	ld	xl, a
	rlc	a
	clr	a
	sbc	a, #0x00
	ld	xh, a
	sllw	x
	ldw	x, (_lstk+0, x)
	ldw	(0x05, sp), x
;	tbasic.c: 1798: if (((vstep < 0) && (var[index] < vto)) ||
	ldw	y, (0x03, sp)
	jrpl	00168$
	ldw	x, (0x01, sp)
	sllw	x
	ldw	x, (_var+0, x)
	cpw	x, (0x05, sp)
	jrslt	00164$
00168$:
;	tbasic.c: 1799: ((vstep > 0) && (var[index] > vto)))
	cpw	y, #0x0000
	jrsle	00165$
	ldw	x, (0x01, sp)
	sllw	x
	ldw	x, (_var+0, x)
	cpw	x, (0x05, sp)
	jrsle	00165$
00164$:
;	tbasic.c: 1801: lstki -= 5;
	ld	a, _lstki+0
	sub	a, #0x05
	ld	_lstki+0, a
;	tbasic.c: 1802: break;
	jp	00193$
00165$:
;	tbasic.c: 1806: cip = lstk[lstki - 4];
	ld	a, _lstki+0
	ld	(0x06, sp), a
	sub	a, #0x04
	ld	xl, a
	rlc	a
	clr	a
	sbc	a, #0x00
	ld	xh, a
	sllw	x
	ldw	x, (_lstk+0, x)
	ldw	_cip+0, x
;	tbasic.c: 1807: clp = lstk[lstki - 5];
	ld	a, (0x06, sp)
	sub	a, #0x05
	ld	xl, a
	rlc	a
	clr	a
	sbc	a, #0x00
	ld	xh, a
	sllw	x
	ldw	x, (_lstk+0, x)
	ldw	_clp+0, x
;	tbasic.c: 1808: break;
	jp	00193$
;	tbasic.c: 1811: case I_IF:
00169$:
;	tbasic.c: 1813: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1814: condition = iexp();
	call	_iexp
;	tbasic.c: 1815: if (err)
	tnz	_err+0
	jreq	00171$
;	tbasic.c: 1817: err = ERR_IFWOC;
	mov	_err+0, #0x0f
;	tbasic.c: 1818: break;
	jp	00193$
00171$:
;	tbasic.c: 1820: if (condition) break;
	tnzw	x
	jreq	00611$
	jp	00193$
00611$:
;	tbasic.c: 1824: while (*cip != I_EOL) cip++;
00175$:
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x2d
	jrne	00613$
	jp	00193$
00613$:
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
	jra	00175$
;	tbasic.c: 1829: while (*clp) clp += *clp;
00179$:
	ldw	x, _clp+0
	ld	a, (x)
	jreq	00181$
	ldw	x, _clp+0
	ld	a, (x)
	clrw	x
	ld	xl, a
	addw	x, _clp+0
	ldw	_clp+0, x
	jra	00179$
00181$:
;	tbasic.c: 1830: return clp;
	ldw	x, _clp+0
	jra	00199$
;	tbasic.c: 1832: case I_VAR:
00182$:
;	tbasic.c: 1834: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1835: ivar();
	call	_ivar
;	tbasic.c: 1836: break;
	jra	00193$
;	tbasic.c: 1838: case I_ARRAY:
00183$:
;	tbasic.c: 1840: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1841: iarray();
	call	_iarray
;	tbasic.c: 1842: break;
	jra	00193$
;	tbasic.c: 1844: case I_OUT:
00184$:
;	tbasic.c: 1846: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1847: ioutput();
	call	_ioutput
;	tbasic.c: 1848: break;
	jra	00193$
;	tbasic.c: 1850: case I_LET:
00185$:
;	tbasic.c: 1852: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1853: ilet();
	call	_ilet
;	tbasic.c: 1854: break;
	jra	00193$
;	tbasic.c: 1856: case I_PRINT:
00186$:
;	tbasic.c: 1858: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1859: iprint();
	call	_iprint
;	tbasic.c: 1860: break;
	jra	00193$
;	tbasic.c: 1862: case I_INPUT:
00187$:
;	tbasic.c: 1864: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1865: iinput();
	call	_iinput
;	tbasic.c: 1866: break;
	jra	00193$
;	tbasic.c: 1870: case I_RUN:
00190$:
;	tbasic.c: 1872: err = ERR_COM;
	mov	_err+0, #0x13
;	tbasic.c: 1873: break;
	jra	00193$
;	tbasic.c: 1875: case I_SEMI:
00191$:
;	tbasic.c: 1877: cip++;
	ldw	x, _cip+0
	incw	x
	ldw	_cip+0, x
;	tbasic.c: 1878: break;
	jra	00193$
;	tbasic.c: 1881: default:
00192$:
;	tbasic.c: 1883: err = ERR_SYNTAX;
	mov	_err+0, #0x14
;	tbasic.c: 1886: }
00193$:
;	tbasic.c: 1888: if (err) return NULL;
	tnz	_err+0
	jrne	00616$
	jp	00196$
00616$:
	clrw	x
	jra	00199$
00198$:
;	tbasic.c: 1890: return clp + *clp;
	ldw	x, _clp+0
	ld	a, (x)
	clrw	x
	ld	xl, a
	addw	x, _clp+0
00199$:
;	tbasic.c: 1891: }
	addw	sp, #6
	ret
;	tbasic.c: 1893: void irun(void)
;	-----------------------------------------
;	 function irun
;	-----------------------------------------
_irun:
;	tbasic.c: 1897: gstki = 0;
	clr	_gstki+0
;	tbasic.c: 1898: lstki = 0;
	clr	_lstki+0
;	tbasic.c: 1899: clp = listbuf;
	ldw	x, #(_listbuf+0)
	ldw	_clp+0, x
;	tbasic.c: 1901: while (*clp)
00103$:
	ldw	x, _clp+0
	ld	a, (x)
	jrne	00123$
	ret
00123$:
;	tbasic.c: 1903: cip = clp + 3;
	ldw	x, _clp+0
	addw	x, #0x0003
	ldw	_cip+0, x
;	tbasic.c: 1904: lp = iexe();
	call	_iexe
;	tbasic.c: 1905: if (err) return;
	tnz	_err+0
	jreq	00102$
	ret
00102$:
;	tbasic.c: 1906: clp = lp;
	ldw	_clp+0, x
	jra	00103$
;	tbasic.c: 1908: }
	ret
;	tbasic.c: 1910: void ilist(void)
;	-----------------------------------------
;	 function ilist
;	-----------------------------------------
_ilist:
	pushw	x
;	tbasic.c: 1914: lineno = (*cip == I_NUM) ? getlineno(cip) : 0;
	ldw	x, _cip+0
	ld	a, (x)
	cp	a, #0x2a
	jrne	00113$
	ldw	x, _cip+0
	pushw	x
	call	_getlineno
	addw	sp, #2
	.byte 0x21
00113$:
	clrw	x
00114$:
	ldw	(0x01, sp), x
;	tbasic.c: 1916: for (clp = listbuf;
	ldw	x, #(_listbuf+0)
	ldw	_clp+0, x
00109$:
;	tbasic.c: 1917: *clp && (getlineno(clp) < lineno);
	ldw	x, _clp+0
	ld	a, (x)
	jreq	00104$
	ldw	x, _clp+0
	pushw	x
	call	_getlineno
	addw	sp, #2
	cpw	x, (0x01, sp)
	jrsge	00104$
;	tbasic.c: 1918: clp += *clp);
	ldw	x, _clp+0
	ld	a, (x)
	clrw	x
	ld	xl, a
	addw	x, _clp+0
	ldw	_clp+0, x
	jra	00109$
;	tbasic.c: 1920: while (*clp)
00104$:
	ldw	x, _clp+0
	ld	a, (x)
	jreq	00111$
;	tbasic.c: 1922: putnum(getlineno(clp), 0);
	ldw	x, _clp+0
	pushw	x
	call	_getlineno
	addw	sp, #2
	push	#0x00
	push	#0x00
	pushw	x
	call	_putnum
	addw	sp, #4
;	tbasic.c: 1923: uart_putchar(' ');
	push	#0x20
	call	_uart_putchar
	pop	a
;	tbasic.c: 1924: putlist(clp + 3);
	ldw	x, _clp+0
	addw	x, #0x0003
	pushw	x
	call	_putlist
	popw	x
;	tbasic.c: 1925: if (err) break;
	tnz	_err+0
	jrne	00111$
;	tbasic.c: 1926: newline();
	call	_newline
;	tbasic.c: 1927: clp += *clp;
	ldw	x, _clp+0
	ld	a, (x)
	clrw	x
	ld	xl, a
	addw	x, _clp+0
	ldw	_clp+0, x
	jra	00104$
00111$:
;	tbasic.c: 1930: }
	popw	x
	ret
;	tbasic.c: 1932: void inew(void)
;	-----------------------------------------
;	 function inew
;	-----------------------------------------
_inew:
;	tbasic.c: 1936: for (i = 0; i < 26; i++) var[i] = 0;
	clr	a
00103$:
	clrw	x
	ld	xl, a
	sllw	x
	addw	x, #(_var+0)
	clr	(0x1, x)
	clr	(x)
	inc	a
	cp	a, #0x1a
	jrc	00103$
;	tbasic.c: 1937: for (i = 0; i < SIZE_ARRY; i++) arr[i] = 0;
	clr	a
00105$:
	clrw	x
	ld	xl, a
	sllw	x
	addw	x, #(_arr+0)
	clr	(0x1, x)
	clr	(x)
	inc	a
	cp	a, #0x20
	jrc	00105$
;	tbasic.c: 1938: gstki = 0;
	clr	_gstki+0
;	tbasic.c: 1939: lstki = 0;
	clr	_lstki+0
;	tbasic.c: 1940: *listbuf = 0;
	ldw	x, #_listbuf+0
	clr	(x)
;	tbasic.c: 1941: clp = listbuf;
	ldw	_clp+0, x
;	tbasic.c: 1942: }
	ret
;	tbasic.c: 1944: void icom(void)
;	-----------------------------------------
;	 function icom
;	-----------------------------------------
_icom:
;	tbasic.c: 1950: cip = ibuf;
	ldw	x, #(_ibuf+0)
;	tbasic.c: 1951: switch (*cip)
	ldw	_cip+0, x
	ld	a, (x)
;	tbasic.c: 1966: cip++;
	ldw	x, _cip+0
	incw	x
;	tbasic.c: 1951: switch (*cip)
	cp	a, #0x22
	jreq	00107$
	cp	a, #0x23
	jreq	00112$
	cp	a, #0x24
	jreq	00103$
	cp	a, #0x25
	jrne	00162$
	jp	_saveprog
00162$:
	cp	a, #0x26
	jrne	00165$
	jp	_loadprog
00165$:
;	tbasic.c: 1953: case I_SAVE:
;	tbasic.c: 1955: saveprog();
;	tbasic.c: 1956: break;
;	tbasic.c: 1958: case I_LOAD:
;	tbasic.c: 1960: loadprog();
;	tbasic.c: 1961: break;
	jp	_iexe
;	tbasic.c: 1964: case I_NEW:
00103$:
;	tbasic.c: 1966: cip++;
;	tbasic.c: 1967: if (*cip == I_EOL)
	ldw	_cip+0, x
	ld	a, (x)
	cp	a, #0x2d
	jrne	00105$
;	tbasic.c: 1968: inew();
	jp	_inew
00105$:
;	tbasic.c: 1970: err = ERR_SYNTAX;
	mov	_err+0, #0x14
;	tbasic.c: 1971: break;
	ret
;	tbasic.c: 1973: case I_LIST:
00107$:
;	tbasic.c: 1975: cip++;
;	tbasic.c: 1976: if (*cip == I_EOL || *(cip + 3) == I_EOL)
	ldw	_cip+0, x
	ld	a, (x)
	cp	a, #0x2d
	jrne	00171$
	jp	_ilist
00171$:
	ldw	x, _cip+0
	ld	a, (0x3, x)
	cp	a, #0x2d
	jrne	00109$
;	tbasic.c: 1977: ilist();
	jp	_ilist
00109$:
;	tbasic.c: 1979: err = ERR_SYNTAX;
	mov	_err+0, #0x14
;	tbasic.c: 1980: break;
	ret
;	tbasic.c: 1982: case I_RUN:
00112$:
;	tbasic.c: 1984: cip++;
	ldw	_cip+0, x
;	tbasic.c: 1985: irun();
;	tbasic.c: 1986: break;
;	tbasic.c: 1988: default:
;	tbasic.c: 1990: iexe();
;	tbasic.c: 1993: }
;	tbasic.c: 1994: }
	jp	_irun
;	tbasic.c: 1996: void error()
;	-----------------------------------------
;	 function error
;	-----------------------------------------
_error:
	pushw	x
;	tbasic.c: 1999: if (err)
	tnz	_err+0
	jreq	00107$
;	tbasic.c: 2001: if (cip >= listbuf && cip < listbuf + SIZE_LIST && *clp)
	ld	a, _cip+1
	cp	a, #<(_listbuf+0)
	ld	a, _cip+0
	sbc	a, #((_listbuf+0) >> 8)
	jrc	00102$
	ldw	x, #(_listbuf+0)+512
	ldw	(0x01, sp), x
	cpw	x, _cip+0
	jrule	00102$
	ldw	x, _clp+0
	ld	a, (x)
	jreq	00102$
;	tbasic.c: 2003: newline();
	call	_newline
;	tbasic.c: 2004: uart_putstring("LINE:");
	push	#<(___str_6+0)
	push	#((___str_6+0) >> 8)
	call	_uart_putstring
	popw	x
;	tbasic.c: 2005: putnum(getlineno(clp), 0);
	ldw	x, _clp+0
	pushw	x
	call	_getlineno
	addw	sp, #2
	push	#0x00
	push	#0x00
	pushw	x
	call	_putnum
	addw	sp, #4
;	tbasic.c: 2006: uart_putchar(' ');
	push	#0x20
	call	_uart_putchar
	pop	a
;	tbasic.c: 2007: putlist(clp + 3);
	ldw	x, _clp+0
	addw	x, #0x0003
	pushw	x
	call	_putlist
	popw	x
	jra	00107$
00102$:
;	tbasic.c: 2011: newline();
	call	_newline
;	tbasic.c: 2012: uart_putstring("YOU TYPE: ");
	push	#<(___str_7+0)
	push	#((___str_7+0) >> 8)
	call	_uart_putstring
	popw	x
;	tbasic.c: 2013: uart_putstring(lbuf);
	push	#<(_lbuf+0)
	push	#((_lbuf+0) >> 8)
	call	_uart_putstring
	popw	x
00107$:
;	tbasic.c: 2016: newline();
	call	_newline
;	tbasic.c: 2017: uart_putstring((char *)errmsg[err]);
	ld	a, _err+0
	clrw	x
	ld	xl, a
	sllw	x
	ldw	x, (_errmsg+0, x)
	pushw	x
	call	_uart_putstring
	popw	x
;	tbasic.c: 2018: newline();
	call	_newline
;	tbasic.c: 2019: err = 0;
	clr	_err+0
;	tbasic.c: 2020: }
	popw	x
	ret
;	tbasic.c: 2028: void basic()
;	-----------------------------------------
;	 function basic
;	-----------------------------------------
_basic:
;	tbasic.c: 2034: uart_putstring("\n\STM8S103F3P6 TBasic\n\r");
	push	#<(___str_8+0)
	push	#((___str_8+0) >> 8)
	call	_uart_putstring
	popw	x
;	tbasic.c: 2036: error();                              // Fehlerflag loeschen, OK als Prompt
	call	_error
;	tbasic.c: 2038: if (is_autorun())
	ld	a, 0x5001
	and	a, #0x02
	ld	xl, a
	clr	a
	ld	xh, a
	sraw	x
	tnzw	x
	jrne	00110$
;	tbasic.c: 2040: uart_putstring("\n\rAutoload...");
	push	#<(___str_9+0)
	push	#((___str_9+0) >> 8)
	call	_uart_putstring
	popw	x
;	tbasic.c: 2041: strcpy(lbuf,"load");
	push	#<(___str_10+0)
	push	#((___str_10+0) >> 8)
	push	#<(_lbuf+0)
	push	#((_lbuf+0) >> 8)
	call	_strcpy
	addw	sp, #4
;	tbasic.c: 2042: len = toktoi();
	call	_toktoi
;	tbasic.c: 2043: icom();
	call	_icom
;	tbasic.c: 2044: uart_putstring("\n\rProgram running\n\r");
	push	#<(___str_11+0)
	push	#((___str_11+0) >> 8)
	call	_uart_putstring
	popw	x
;	tbasic.c: 2045: strcpy(lbuf,"run");
	push	#<(___str_12+0)
	push	#((___str_12+0) >> 8)
	push	#<(_lbuf+0)
	push	#((_lbuf+0) >> 8)
	call	_strcpy
	addw	sp, #4
;	tbasic.c: 2046: len = toktoi();
	call	_toktoi
;	tbasic.c: 2047: icom();
	call	_icom
;	tbasic.c: 2049: error();
	call	_error
;	tbasic.c: 2054: while (1)
00110$:
;	tbasic.c: 2056: uart_putstring("> ");
	push	#<(___str_13+0)
	push	#((___str_13+0) >> 8)
	call	_uart_putstring
	popw	x
;	tbasic.c: 2057: uart_getstring();
	call	_uart_getstring
;	tbasic.c: 2059: len = toktoi();
	call	_toktoi
	ld	yl, a
;	tbasic.c: 2060: if (err)
	tnz	_err+0
	jreq	00104$
;	tbasic.c: 2062: error();
	call	_error
;	tbasic.c: 2063: continue;
	jra	00110$
00104$:
;	tbasic.c: 2066: if (*ibuf == I_NUM)
	ldw	x, #_ibuf+0
	ld	a, (x)
	cp	a, #0x2a
	jrne	00108$
;	tbasic.c: 2068: *ibuf = len;
	ld	a, yl
	ld	(x), a
;	tbasic.c: 2069: inslist();
	call	_inslist
;	tbasic.c: 2070: if (err)  error();
	tnz	_err+0
	jreq	00110$
	call	_error
;	tbasic.c: 2071: continue;
	jra	00110$
00108$:
;	tbasic.c: 2074: icom();                     // direkte Kommandoausfuehrung
	call	_icom
;	tbasic.c: 2075: error();                    // Fehler loeschen, OK ausgeben
	call	_error
	jra	00110$
;	tbasic.c: 2077: }
	ret
;	tbasic.c: 2079: void sysfunc(int16_t v1, int16_t v2)
;	-----------------------------------------
;	 function sysfunc
;	-----------------------------------------
_sysfunc:
;	tbasic.c: 2081: switch (v1)
	ldw	x, (0x03, sp)
	decw	x
	jreq	00113$
	ret
00113$:
;	tbasic.c: 2085: uart_putchar(v2 & 0xff);
	ld	a, (0x06, sp)
	push	a
	call	_uart_putchar
	pop	a
;	tbasic.c: 2089: }
;	tbasic.c: 2090: }
	ret
;	tbasic.c: 2096: int main(void)
;	-----------------------------------------
;	 function main
;	-----------------------------------------
_main:
;	tbasic.c: 2099: sysclock_init(0);
	push	#0x00
	call	_sysclock_init
	pop	a
;	tbasic.c: 2100: adc_init();
	mov	0x5400+0, #0x03
	bset	21505, #0
;	tbasic.c: 2101: uart_init();
	call	_uart_init
;	tbasic.c: 2102: autorun_init();  
	bres	20482, #1
	bset	20483, #1
;	tbasic.c: 2104: inew();
	call	_inew
;	tbasic.c: 2106: basic();
	call	_basic
;	tbasic.c: 2107: return 0;
	clrw	x
;	tbasic.c: 2108: }
	ret
	.area CODE
	.area CONST
	.area CONST
___str_0:
	.db 0x0a
	.db 0x0d
	.db 0x00
	.area CODE
_i_nsa:
	.db #0x02	; 2
	.db #0x09	; 9
	.db #0x0d	; 13
	.db #0x0f	; 15
	.db #0x10	; 16
	.db #0x11	; 17
	.db #0x12	; 18
	.db #0x13	; 19
	.db #0x14	; 20
	.db #0x15	; 21
	.db #0x16	; 22
	.db #0x17	; 23
	.db #0x18	; 24
	.db #0x19	; 25
	.db #0x1a	; 26
	.db #0x1b	; 27
	.db #0x1c	; 28
	.db #0x1d	; 29
	.db #0x1e	; 30
	.db #0x1f	; 31
	.db #0x20	; 32
	.db #0x29	; 41
_i_nsb:
	.db #0x0f	; 15
	.db #0x10	; 16
	.db #0x11	; 17
	.db #0x12	; 18
	.db #0x13	; 19
	.db #0x14	; 20
	.db #0x15	; 21
	.db #0x16	; 22
	.db #0x17	; 23
	.db #0x18	; 24
	.db #0x19	; 25
	.db #0x1a	; 26
	.db #0x0d	; 13
	.db #0x0e	; 14
	.db #0x2d	; 45
_pinmap:
	.db #0x03	; 3
	.db #0x04	; 4
	.db #0x05	; 5
	.db #0x03	; 3
	.db #0x04	; 4
	.db #0x05	; 5
	.db #0x06	; 6
	.db #0x07	; 7
	.db #0x03	; 3
	.db #0x04	; 4
_portmap:
	.db #0x00	; 0
	.db #0x01	; 1
	.db #0x01	; 1
	.db #0x02	; 2
	.db #0x02	; 2
	.db #0x02	; 2
	.db #0x02	; 2
	.db #0x02	; 2
	.db #0x03	; 3
	.db #0x03	; 3
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.area CONST
___str_1:
	.db 0x0a
	.db 0x0d
	.ascii "Done..."
	.db 0x00
	.area CODE
	.area CONST
___str_2:
	.db 0x0a
	.db 0x0d
	.ascii "Loading done..."
	.db 0x00
	.area CODE
	.area CONST
___str_3:
	.ascii ": "
	.db 0x00
	.area CODE
	.area CONST
___str_4:
	.ascii "@("
	.db 0x00
	.area CODE
	.area CONST
___str_5:
	.ascii "):"
	.db 0x00
	.area CODE
	.area CONST
___str_6:
	.ascii "LINE:"
	.db 0x00
	.area CODE
	.area CONST
___str_7:
	.ascii "YOU TYPE: "
	.db 0x00
	.area CODE
	.area CONST
___str_8:
	.db 0x0a
	.ascii "STM8S103F3P6 TBasic"
	.db 0x0a
	.db 0x0d
	.db 0x00
	.area CODE
	.area CONST
___str_9:
	.db 0x0a
	.db 0x0d
	.ascii "Autoload..."
	.db 0x00
	.area CODE
	.area CONST
___str_10:
	.ascii "load"
	.db 0x00
	.area CODE
	.area CONST
___str_11:
	.db 0x0a
	.db 0x0d
	.ascii "Program running"
	.db 0x0a
	.db 0x0d
	.db 0x00
	.area CODE
	.area CONST
___str_12:
	.ascii "run"
	.db 0x00
	.area CODE
	.area CONST
___str_13:
	.ascii "> "
	.db 0x00
	.area CODE
	.area CONST
___str_14:
	.ascii "GOTO"
	.db 0x00
	.area CODE
	.area CONST
___str_15:
	.ascii "GOSUB"
	.db 0x00
	.area CODE
	.area CONST
___str_16:
	.ascii "RETURN"
	.db 0x00
	.area CODE
	.area CONST
___str_17:
	.ascii "FOR"
	.db 0x00
	.area CODE
	.area CONST
___str_18:
	.ascii "TO"
	.db 0x00
	.area CODE
	.area CONST
___str_19:
	.ascii "STEP"
	.db 0x00
	.area CODE
	.area CONST
___str_20:
	.ascii "NEXT"
	.db 0x00
	.area CODE
	.area CONST
___str_21:
	.ascii "IF"
	.db 0x00
	.area CODE
	.area CONST
___str_22:
	.ascii "REM"
	.db 0x00
	.area CODE
	.area CONST
___str_23:
	.ascii "STOP"
	.db 0x00
	.area CODE
	.area CONST
___str_24:
	.ascii "INPUT"
	.db 0x00
	.area CODE
	.area CONST
___str_25:
	.ascii "PRINT"
	.db 0x00
	.area CODE
	.area CONST
___str_26:
	.ascii "LET"
	.db 0x00
	.area CODE
	.area CONST
___str_27:
	.ascii ","
	.db 0x00
	.area CODE
	.area CONST
___str_28:
	.ascii ";"
	.db 0x00
	.area CODE
	.area CONST
___str_29:
	.ascii "-"
	.db 0x00
	.area CODE
	.area CONST
___str_30:
	.ascii "+"
	.db 0x00
	.area CODE
	.area CONST
___str_31:
	.ascii "*"
	.db 0x00
	.area CODE
	.area CONST
___str_32:
	.ascii "/"
	.db 0x00
	.area CODE
	.area CONST
___str_33:
	.ascii "("
	.db 0x00
	.area CODE
	.area CONST
___str_34:
	.ascii ")"
	.db 0x00
	.area CODE
	.area CONST
___str_35:
	.ascii ">="
	.db 0x00
	.area CODE
	.area CONST
___str_36:
	.ascii "#"
	.db 0x00
	.area CODE
	.area CONST
___str_37:
	.ascii ">"
	.db 0x00
	.area CODE
	.area CONST
___str_38:
	.ascii "="
	.db 0x00
	.area CODE
	.area CONST
___str_39:
	.ascii "<="
	.db 0x00
	.area CODE
	.area CONST
___str_40:
	.ascii "<"
	.db 0x00
	.area CODE
	.area CONST
___str_41:
	.ascii "@"
	.db 0x00
	.area CODE
	.area CONST
___str_42:
	.ascii "RND"
	.db 0x00
	.area CODE
	.area CONST
___str_43:
	.ascii "ABS"
	.db 0x00
	.area CODE
	.area CONST
___str_44:
	.ascii "SIZE"
	.db 0x00
	.area CODE
	.area CONST
___str_45:
	.ascii "OUT"
	.db 0x00
	.area CODE
	.area CONST
___str_46:
	.ascii "IN"
	.db 0x00
	.area CODE
	.area CONST
___str_47:
	.ascii "FUNC"
	.db 0x00
	.area CODE
	.area CONST
___str_48:
	.ascii "LIST"
	.db 0x00
	.area CODE
	.area CONST
___str_49:
	.ascii "RUN"
	.db 0x00
	.area CODE
	.area CONST
___str_50:
	.ascii "NEW"
	.db 0x00
	.area CODE
	.area CONST
___str_51:
	.ascii "SAVE"
	.db 0x00
	.area CODE
	.area CONST
___str_52:
	.ascii "LOAD"
	.db 0x00
	.area CODE
	.area CONST
___str_53:
	.ascii "BYTEOUT"
	.db 0x00
	.area CODE
	.area CONST
___str_54:
	.ascii "DELAY"
	.db 0x00
	.area CODE
	.area CONST
___str_55:
	.ascii "ADC"
	.db 0x00
	.area CODE
	.area CONST
___str_56:
	.ascii "OK"
	.db 0x00
	.area CODE
	.area CONST
___str_57:
	.ascii "Err1"
	.db 0x00
	.area CODE
	.area CONST
___str_58:
	.ascii "Err2"
	.db 0x00
	.area CODE
	.area CONST
___str_59:
	.ascii "Err3"
	.db 0x00
	.area CODE
	.area CONST
___str_60:
	.ascii "Err4"
	.db 0x00
	.area CODE
	.area CONST
___str_61:
	.ascii "Err5"
	.db 0x00
	.area CODE
	.area CONST
___str_62:
	.ascii "Err6"
	.db 0x00
	.area CODE
	.area CONST
___str_63:
	.ascii "Err7"
	.db 0x00
	.area CODE
	.area CONST
___str_64:
	.ascii "Err8"
	.db 0x00
	.area CODE
	.area CONST
___str_65:
	.ascii "Err9"
	.db 0x00
	.area CODE
	.area CONST
___str_66:
	.ascii "Err10"
	.db 0x00
	.area CODE
	.area CONST
___str_67:
	.ascii "Err11"
	.db 0x00
	.area CODE
	.area CONST
___str_68:
	.ascii "Err12"
	.db 0x00
	.area CODE
	.area CONST
___str_69:
	.ascii "Err13"
	.db 0x00
	.area CODE
	.area CONST
___str_70:
	.ascii "Err14"
	.db 0x00
	.area CODE
	.area CONST
___str_71:
	.ascii "Err15"
	.db 0x00
	.area CODE
	.area CONST
___str_72:
	.ascii "Err16"
	.db 0x00
	.area CODE
	.area CONST
___str_73:
	.ascii "Err17"
	.db 0x00
	.area CODE
	.area CONST
___str_74:
	.ascii "Err18"
	.db 0x00
	.area CODE
	.area CONST
___str_75:
	.ascii "Err19"
	.db 0x00
	.area CODE
	.area CONST
___str_76:
	.ascii "Err20"
	.db 0x00
	.area CODE
	.area CONST
___str_77:
	.ascii "Err21"
	.db 0x00
	.area CODE
	.area CONST
___str_78:
	.ascii "ESC-Break"
	.db 0x00
	.area CODE
	.area CONST
___str_79:
	.ascii "Err23"
	.db 0x00
	.area CODE
	.area CONST
___str_80:
	.ascii "Err24"
	.db 0x00
	.area CODE
	.area CONST
___str_81:
	.ascii "Err25"
	.db 0x00
	.area CODE
	.area INITIALIZER
__xinit__kwtbl:
	.dw ___str_14
	.dw ___str_15
	.dw ___str_16
	.dw ___str_17
	.dw ___str_18
	.dw ___str_19
	.dw ___str_20
	.dw ___str_21
	.dw ___str_22
	.dw ___str_23
	.dw ___str_24
	.dw ___str_25
	.dw ___str_26
	.dw ___str_27
	.dw ___str_28
	.dw ___str_29
	.dw ___str_30
	.dw ___str_31
	.dw ___str_32
	.dw ___str_33
	.dw ___str_34
	.dw ___str_35
	.dw ___str_36
	.dw ___str_37
	.dw ___str_38
	.dw ___str_39
	.dw ___str_40
	.dw ___str_41
	.dw ___str_42
	.dw ___str_43
	.dw ___str_44
	.dw ___str_45
	.dw ___str_46
	.dw ___str_47
	.dw ___str_48
	.dw ___str_49
	.dw ___str_50
	.dw ___str_51
	.dw ___str_52
	.dw ___str_53
	.dw ___str_54
	.dw ___str_55
__xinit__errmsg:
	.dw ___str_56
	.dw ___str_57
	.dw ___str_58
	.dw ___str_59
	.dw ___str_60
	.dw ___str_61
	.dw ___str_62
	.dw ___str_63
	.dw ___str_64
	.dw ___str_65
	.dw ___str_66
	.dw ___str_67
	.dw ___str_68
	.dw ___str_69
	.dw ___str_70
	.dw ___str_71
	.dw ___str_72
	.dw ___str_73
	.dw ___str_74
	.dw ___str_75
	.dw ___str_76
	.dw ___str_77
	.dw ___str_78
	.dw ___str_79
	.dw ___str_80
	.dw ___str_81
__xinit__portddr:
	.dw #0x0000
	.area CABS (ABS)
