;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.1.0 #12072 (Linux)
;--------------------------------------------------------
	.module stm8_init
	.optsdcc -mstm8
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _sysclock_init
	.globl _delay
	.globl _delay_us
	.globl _int_enable
	.globl _int_disable
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area DABS (ABS)

; default segment ordering for linker
	.area HOME
	.area GSINIT
	.area GSFINAL
	.area CONST
	.area INITIALIZER
	.area CODE

;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area HOME
	.area GSINIT
	.area GSFINAL
	.area GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME
	.area HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CODE
;	../src/stm8_init.c: 39: void sysclock_init(char xtalen)
;	-----------------------------------------
;	 function sysclock_init
;	-----------------------------------------
_sysclock_init:
;	../src/stm8_init.c: 41: if (xtalen)
	tnz	(0x03, sp)
	jreq	00111$
;	../src/stm8_init.c: 43: CLK_ICKR = 0;                                  //  Reset Register interner clock
	mov	0x50c0+0, #0x00
;	../src/stm8_init.c: 44: CLK_ECKR = HSEEN;
	mov	0x50c1+0, #0x01
;	../src/stm8_init.c: 46: while ((CLK_ECKR & HSERDY) == 0);              //  warten bis Quarz eingeschwungen ist;
00101$:
	ld	a, 0x50c1
	bcp	a, #0x02
	jreq	00101$
;	../src/stm8_init.c: 48: CLK_SWR = 0xb4;                                //  int. Generator als Taktquelle
	mov	0x50c4+0, #0xb4
;	../src/stm8_init.c: 50: CLK_SWCR = SWEN;                               //  Enable switching.
	mov	0x50c5+0, #0x02
;	../src/stm8_init.c: 52: CLK_CKDIVR = 0;                                //  Taktteiler auf volle Geschwindigkeit
	mov	0x50c6+0, #0x00
;	../src/stm8_init.c: 53: CLK_PCKENR1 = 0xff;                            //  alle Peripherietakte an
	mov	0x50c7+0, #0xff
;	../src/stm8_init.c: 54: CLK_PCKENR2 = 0xff;                            //  dto.
	mov	0x50ca+0, #0xff
	jra	00112$
00111$:
;	../src/stm8_init.c: 58: CLK_ICKR = 0;                                  //  Reset Register interner clock
	mov	0x50c0+0, #0x00
;	../src/stm8_init.c: 59: CLK_ECKR = 0;                                  //  Reset Register externer clock (ext. clock disable)
	mov	0x50c1+0, #0x00
;	../src/stm8_init.c: 61: CLK_ICKR =  HSIEN;                             //  Interner clock enable
	mov	0x50c0+0, #0x01
;	../src/stm8_init.c: 62: while ((CLK_ICKR & (HSIRDY)) == 0);            //  warten bis int. Takt eingeschwungen ist
00104$:
	ld	a, 0x50c0
	bcp	a, #0x02
	jreq	00104$
;	../src/stm8_init.c: 65: CLK_CKDIVR = 0;                                //  Taktteiler auf volle Geschwindigkeit
	mov	0x50c6+0, #0x00
;	../src/stm8_init.c: 66: CLK_PCKENR1 = 0xff;                            //  alle Peripherietakte an
	mov	0x50c7+0, #0xff
;	../src/stm8_init.c: 67: CLK_PCKENR2 = 0xff;                            //  dto.
	mov	0x50ca+0, #0xff
;	../src/stm8_init.c: 69: CLK_CCOR = 0;                                  //  CCO aus
	mov	0x50c9+0, #0x00
;	../src/stm8_init.c: 70: CLK_HSITRIMR = 0;                              //  keine Taktjustierung
	mov	0x50cc+0, #0x00
;	../src/stm8_init.c: 71: CLK_SWIMCCR = 0;                               //  SWIM = clock / 2.
	mov	0x50cd+0, #0x00
;	../src/stm8_init.c: 72: CLK_SWR = 0xe1;                                //  int. Generator als Taktquelle
	mov	0x50c4+0, #0xe1
;	../src/stm8_init.c: 73: CLK_SWCR = 0;                                  //  Reset clock switch control register.
	mov	0x50c5+0, #0x00
;	../src/stm8_init.c: 74: CLK_SWCR = SWEN;                               //  Enable switching.
	mov	0x50c5+0, #0x02
;	../src/stm8_init.c: 75: while ((CLK_SWCR &  SWBSY) != 0);              //  warten bis Peripherietakt stabil
00107$:
	ld	a, 0x50c5
	bcp	a, #0x08
	jrne	00107$
00112$:
;	../src/stm8_init.c: 77: delay(50);
	push	#0x32
	push	#0x00
	call	_delay
	popw	x
;	../src/stm8_init.c: 78: }
	ret
;	../src/stm8_init.c: 88: void delay(uint16_t cnt)
;	-----------------------------------------
;	 function delay
;	-----------------------------------------
_delay:
	pushw	x
;	../src/stm8_init.c: 92: while (cnt)
	ldw	x, (0x05, sp)
00104$:
	tnzw	x
	jreq	00107$
;	../src/stm8_init.c: 94: cnt2= 1435;
	ldw	y, #0x059b
	ldw	(0x01, sp), y
;	../src/stm8_init.c: 95: while(cnt2)
00101$:
	ldw	y, (0x01, sp)
	jreq	00103$
;	../src/stm8_init.c: 97: cnt2--;
	ldw	y, (0x01, sp)
	decw	y
	ldw	(0x01, sp), y
	jra	00101$
00103$:
;	../src/stm8_init.c: 99: cnt--;
	decw	x
	jra	00104$
00107$:
;	../src/stm8_init.c: 101: }
	popw	x
	ret
;	../src/stm8_init.c: 109: void delay_us(uint16_t anz)
;	-----------------------------------------
;	 function delay_us
;	-----------------------------------------
_delay_us:
	pushw	x
;	../src/stm8_init.c: 113: for (count= 0; count< anz; count++)
	clrw	x
	ldw	(0x01, sp), x
00103$:
	ldw	x, (0x01, sp)
	cpw	x, (0x05, sp)
	jrnc	00105$
;	../src/stm8_init.c: 117: __endasm;
	nop
;	../src/stm8_init.c: 113: for (count= 0; count< anz; count++)
	ldw	x, (0x01, sp)
	incw	x
	ldw	(0x01, sp), x
	jra	00103$
00105$:
;	../src/stm8_init.c: 119: }
	popw	x
	ret
;	../src/stm8_init.c: 131: void int_enable(void)
;	-----------------------------------------
;	 function int_enable
;	-----------------------------------------
_int_enable:
;	../src/stm8_init.c: 135: __endasm;
;
	rim
;	../src/stm8_init.c: 136: }
	ret
;	../src/stm8_init.c: 148: void int_disable(void)
;	-----------------------------------------
;	 function int_disable
;	-----------------------------------------
_int_disable:
;	../src/stm8_init.c: 152: __endasm;
;
	sim
;	../src/stm8_init.c: 153: }
	ret
	.area CODE
	.area CONST
	.area INITIALIZER
	.area CABS (ABS)
